/* 09 April 2001. SRE-http addon and generic CGI-BIN script:
  Create and retrieve thumbnails

WWWTHUMB ver 1.2

This program will work as:
 1) a SRE-http add-on,
 2) a generic CGI-BIN script
 3) a stand/alone program
 4) called as an external procedure with VERB=LOOKUP
    (must be in the goserve working directory)
...it will automatically detect how it's being called.

Note: YOU MUST SET the thumbnail_dir and thumbnail_dir_sel parameters (below)!

*/


/* ********   BEGIN user changable options         **********   */
/* ********   BEGIN user changable options       ***********    */

/*     ------  You Must Set the THUMBNAIL_DIR parameter !         ----   */

/*BEGIN --- */

    /* Enter fully-qualfied directory in which thumbnail files should be stored. */
THUMBNAIL_DIR='thumcash'

  /* SRE-http users only:
     Enter the "selector" corresponding to thumbnail_dir.
     SRE-http users can leave this blank, in which case wwwthumb.cmd
     will return the thumbnail directly (WWWcount will not use redirection) */
THUMBNAIL_DIR_SEL='thumcash'

  /*  Fully qualified directory containing the "default thumbnails". */
IMG_DIR='d:\www\imgs'

  /* SRE-http users only:
     Set to 1 to suppress "on the fly" creation of thumbnails,
     Set to 2 to also suppress use of defaults (ONLY use if in a thumbnail index)
     For SUPERUSERS and THUMBNAIL privilege holders, not_on_the_fly
     is ignored.
     Note: when called as a cgi-bin, on the fly creation of thumbnails,
           and use of defaults, is NOT available (you MUST create
           a thumbnail index first!)*/
NOT_ON_THE_FLY=0


  /*SRE-http users only:
     Selector to use for "return to thumbnail creation program" link
    (after viewing creating new indices, this is displayed along with a
     "show the contents of this index".
     This is sort of deprecated, since thumbsre.htm launches a
     new window when it creates thumbnails -- "returning to thumbnail
     creation page" will cause a second version of the thumbsre.htm
     to be opened" */
WWWTHUMB_SEL=''

  /* Pad entries in index (at end) with this string. Useful to save
    space for later addition (by hand) of "descriptions" (i.e.; instead
    of dimensions info). To suppress, set pad_with='' */
PAD_WITH='       '

  /* X ,y dimensions to save, or convert, thumbnails to. Leave blank
   to use defaults (no change for existing thumbnails, 32x32 for gif generated ones */
THUMBNAIL_SIZE='32 32 '

  /* How to scale thumbnails created from .GIF files
          0 = just fit to thunbnail dimensions
          1 = fit to mininum of .GIF image and thumbnail dimensions
          2 = proportionately shrink to fit into thumbnail  */
HOW_SCALE=1

  /* r,g,b color to use when writing size, using rrggbb; with
     rr (and gg and bb) a hex number (00 to ff) */
TEXT_COLOR='aaaaFF'

  /*  r,g,b colors for  background. Or, set to color table # (0 to 255)*/
TEXT_BCOLOR='223344'

  /*  height of size-text, in pixels (added to thumbnails of gif files */
TEXT_HEIGHT=10

  /*  width of size-text (each character), in pixels */
TEXT_WIDTH=5.2


/* TABLE cell background colors to use when display multiple column
   table of thumbnails & links to images. */
  tdcs.1='"#aaaaaa"'
  tdcs.2='"#eedd99"'
  tdcs.3='"#99bbdd"'
  tdcs.4='"#ccccff"'
  tdcs.5='"#bbddff"'
  tdcs.6='"#aaaaaa"'
  tdcs.7='"#eedd99"'
  tdcs.8='"#99bbdd"'
  tdcs.9='"#ccccff"'
  tdcs.10='"#bbddff"'

  /* alignment of images when using VIEW THUMBNAILS. Should be one of
     TOP MIDDLE or BOTTOM */
IMGALIGN='TOP'

  /* Stem variable(s) containing list of "default" thumbnails.  
     Each variable  should have at least two substrings (seperated by a space):
       defaults.n=pattern [pattern2...] tfile
    The wildcardable pattern (and pattern2...] is compared against the 
    "selector" (the SEL= field)
    Typically, it's wildcarded to match an  extension (but it can be a 
   specific selector, such as DIR1/INDEX.HTM)
    The tfile should be filename of the thumbnail file.  Relative filenames
    are relative to the img_dir directory 
   Notes:
   * You may include several patterns for a single tfile.
   * The FIRST defaults. entry that matches the desired file is used.
   * You MUST set the defaults.0 entry to be the number of DEFAULTS.n entries. */
DEFAULTS.1='*.TXT *.TEXT *.DOC *.FAQ text.gif'
DEFAULTS.2='*.HTM *.HTM* *.SHT*  text.gif '
DEFAULTS.3='*.PS text.gif'
DEFAULTS.4='*.EXE *.ZIP *.ARC  binary.gif '
DEFAULTS.5='*.AU *.WAV *.MID* *.SND sound.gif'
DEFAULTS.6='*.MPG *.MPEG *.AVI  movie.gif '
DEFAULTS.7='*.GIF *.JPG *.JPEG *.TIF* *.BMP *.PNG image.gif '
DEFAULTS.8='* Unknown.gif '
DEFAULTS.0=8


/* Viewer Window -- if not '' and not '0', then display images in seperate "viewer" window */
VIEWWIN=''

/*END --- */

/* ********   END   user changable options         **********   */
/* ********   END   user changable options         **********   */


      signal on syntax name ayikes 
      signal on error name ayikes 
      signal on halt name ayikes 
      signal on failure name ayikes 


call load_dlls

parse arg  ddir, tempfile, reqstrg,list,verb ,uri,user, ,
          basedir ,workdir,privset,enmadd,transaction,verbose, ,
         servername,host_nickname,homedir,aparam,semqueue,prog_file

if pos(':',thumbnail_dir)=0 then do            /* add drive letter? */
    foo=directory()
    thumbnail_dir=left(foo,2)||thumbnail_dir
end /* do */

/* check for CGI-BIN call, or stand-alond mode */
is_cgi=0
inclusion=''


if verb="" then do    /* is it cgi-bin, or stand alone? */
   method = value("REQUEST_METHOD",,'os2environment')
   if method="" then do         /* stand alone mode */
       thedir='\www'
       call from_keyboard
       exit
   end /* do */
   else do
      is_cgi=1
      if method='GET' then do
          list=value("QUERY_STRING",,'os2environment')
      end
      else do
         tlen = value("CONTENT_LENGTH",,'os2environment')
         list=charin(,,tlen)
      end /* do */
      cgi_action=strip(value('SCRIPT_NAME',,'os2environment'))
      action=cgi_action
      if abbrev(translate(cgi_action),'CGI')=0  & ,
         abbrev(translate(cgi_action),'/CGI')=0   then
          cgi_action='/CGI-BIN/'||strip(cgi_action,'l','/')
   end
end

if is_cgi=0 then do
  action=uri
  method=verb
  if  method="GET" then    parse var uri action '?' list   /* if srehttp addon, get purer version of request string */
end


/* sre-http addon type of request */
/* options are. */
opts.!viewin=viewin
opts.!index=''
opts.!create=0
opts.!viewem=''
opts.!text_color=text_color
opts.!text_bcolor=text_bcolor
opts.!text_height=text_height
opts.!text_width=text_width
opts.!thumbnail_size=thumbnail_size
opts.!dosub=0
opts.!autogif=0
opts.!sel=''
opts.!no_descrip=0
opts.!write_gif_size=0
opts.!write_transparent=0
opts.!inclusion=''
opts.!bigpicture=0
opts.!big_col=0  
opts.!big_row=0
opts.!big_mess='NAME'
opts.!clientmap=0
opts.!vuin=' '
opts.!mapalt=0
opts.!bigheader=''
opts.!desc=' '
opts.!gohome=0
opts.!html_File=''
opts.!adddesc='' 

LIST1=LIST
do until list=""
   parse var list a1 '&' list
   if pos('=',a1)=0 then do
       avar='SEL' ; aval=a1
   end /* do */
   else do
      parse var a1 avar '=' aval
   end
   if aval="" then iterate              /* no value assigned */
   avar=strip(translate(avar)) 
   if abbrev(avar,'WRITE_G')=1 then avar='WRITE_GIF_SIZE'
   if abbrev(avar,'WRITE_T')=1 then avar='WRITE_TRANSPARENT'
   if abbrev(avar,'TEXT_H')=1 then avar='TEXT_HEIGHT'
   if abbrev(avar,'TEXT_W')=1 then avar='TEXT_WIDTH'
   if abbrev(avar,'ADDD')=1 then avar='ADDDESC'
   if abbrev(avar,'TEXT_C')=1 then avar='TEXT_COLOR'
   if abbrev(avar,'TEXT_B')=1 then avar='TEXT_BCOLOR'
   if abbrev(avar,'DESC')=1 then avar='DESC'
   if abbrev(avar,'DIRS')=1 then avar='DIRS'

   if abbrev(avar,'VIEWIN')+abbrev(avar,'VIEW_IN')+abbrev(avar,'VIEW_WIN')>0 then 
      avar='VUIN'
   if abbrev(avar,'SIZE')=1 then avar='THUMBNAIL_SIZE'
   if abbrev(avar,'VIEW')=1 then avar='VIEWEM'
   if abbrev(avar,'MAPALT')=1 then avar='MAPALT'
   if abbrev(avar,'INCL')=1 then avar='INCLUSION'
   if abbrev(avar,'BIG_P')+abbrev(avar,'BIGP')>0 then avar='BIGPICTURE'
   if abbrev(avar,'BIGH')>0 then avar='BIGHEADER'
   if abbrev(avar,'BIG_C')=1 | avar='BIGCOL' then avar='BIG_COL'
   if abbrev(avar,'BIG_R')=1 | avar='BIGROW' then avar='BIG_ROW'
   if abbrev(avar,'BIG_M')=1 | avar='BIGMES' then avar='BIG_MESS'
   if abbrev(avar,'CLIENT')=1 then avar='BIG_CLIENTMAP'
   if abbrev(avar,'NO_DE')=1 then avar='NO_DESCRIP'
   if abbrev(avar,'HTML')=1 then avar='HTML_FILE'
  
   avar='!'||avar
   select
      when avar='!BIGHEADER' then opts.avar=strip(aval)
      otherwise  opts.avar=strip(decodekeyval(translate(aval,' ','+')))
   end
end /* do */

text_color=opts.!text_color
text_bcolor=opts.!text_bcolor
text_height=opts.!text_height
text_width=opts.!text_width
thumbnail_size=opts.!thumbnail_size
docreate=isyes(opts.!create)
dodirlist=isyes(opts.!dirs)


/* bigpicture stuff write filename or other message to bipicture */
if opts.!big_mess=0 | opts.!big_mess='' then opts.!big_Mess='NAME'
opts.!big_mess=translate(opts.!big_mess)

tmp=0
if opts.!write_gif_size='1' | translate(opts.!write_gif_size)='O' then tmp=1
if opts.!write_gif_Size='2' | translate(opts.!write_gif_Size)='U' then tmp=2
opts.!write_Gif_size=tmp

opts.!write_transparent=isyes(opts.!write_transparent)
opts.!dosub=isyes(opts.!dosub)
opts.!autogif=isyes(opts.!autogif)
opts.!no_descrip=isyes(opts.!no_descrip)
if datatype(opts.!viewem)<>'NUM' then opts.!viewem=''
if opts.!viewem=0 then opts.!viewem=''

/* check for actions not supported under cgi */
if is_cgi=1 then do
  if docreate=1 | dodirlist=1 | opts.!viewem<>'' | opts.!ADDDESC<>'' then do
     say 'Content-type: text/html'
     say
     say "<h2>Sorry. Can not remotely create a thumbnail-index using CGI-BIN</h2>"
     say " Due to the limitations of CGI-BIN (such as the inablity of returning intermediate information, "
     say " several WWWThumb features are not supported when running WWWTHumb as a CGI-BIN script."
     say " You can run WWWthumb.CMD in stand-alond mode, or you can run WWWthumb "
     say " as an SRE-http addon (if you are an using the SRE-http WWW server for OS/2)"
     exit
  end
end

/* Create a cache? */
if docreate=1  then do  
  if wordpos('SUPERUSER',translate(privset))+wordpos('THUMBNAIL',translate(privset))=0 then do
      'header add WWW-Authenticate: Basic Realm=<!CREATE_THUMBNAILS>'  /* challenge */
       return sref_response('unauth', "You do not have ThumbNail creation rights ",tempfile,servername)
  end  /* Do */
    'set netbuffer off'
   fixexpire=value(enmadd||'FIX_EXPIRE',,'os2environment')
    fii=value('SREF_PREFIX',,'os2environment')
   if fixexpire>0  & fii='' then  fpp=sref_expire_response(fixexpire,0)


    aa='<html><HEAD><TITLE>ThumbNail Creator </title></head><body>'
    is13=value('SREF_PREFIX',,'os2environment')
    if is13='' then do
       'SEND type text/html  as WWWthumb '
       'VAR NAME   aa'
    end
    else do
       foo=sref_multi_send(aa,,'1S')
    end /* do */

    call from_request is13  /* send 'em all */

   aa='</BODY></HTML>'
   if is13='' then do
       'VAR NAME   aa'
       'send complete '
    end
    else do
       foo=sref_multi_send(aa,,'1E')
    end /* do */


   return 200' '||extract('bytessent')
end   

if opts.!ADDDESC=1 & opts.!Index='*' then do
  call outit '<html><HEAD><TITLE>ThumbNail Index Editor: step 1 of 3 </title></head><body>'

  foo=list_inds(action)
  call outit '</BODY></HTML>'
  call lineout tempfile
  call gofile 'FILE ERASE type text/html name '||tempfile 
  return 200' '||extract('bytessent')
end /* do */

if opts.!ADDDESC=2 | (opts.!adddesc=1 & opts.!Index<>'*') then do
 call outit '<html><HEAD><TITLE>ThumbNail Index Editor: step 2 of 3 </title>'
  call outit '<script language="javascript">'
  call outit 'daVIEW1=window.open("","THUMB_VIEWER",',
                     '"location=NO,MENUBAR=NO,RESIZABLE,DEPENDENT,SCROLLBARS,STATUS=NO,TITLEBAR,TOOLBAR=NO,SCREENX=12,SCREENY=30,height=74,width=74");'
  call outit 'daVIEW1.document.writeln("<head><title>Thumbnail viewer for Index Editor </title></head>");'
  call outit 'daVIEW1.document.writeln("<body>Thumbnails will <br>be displayed here</body>");'

  call outit 'daVIEW2=window.open("","FILE_VIEWER",',
                     '"location=NO,MENUBAR=NO,RESIZABLE,DEPENDENT,SCROLLBARS,STATUS=NO,TITLEBAR,TOOLBAR=NO,SCREENX=212,SCREENY=30,height=274,width=274");'
  call outit 'daVIEW2.document.writeln("<head><title>File viewer for Index Editor </title></head>");'
  call outit 'daVIEW2.document.writeln("<body>Files will be displayed here</body>");'

  call outit 'foo2=window.moveTo(140,140);'
  call outit 'foo2=window.focus();'


  call outit '</script>'
  call outit '</head><body>'
 
  foo=list_inds2(action)
  call outit '</BODY></HTML>'
  call lineout tempfile
  call gofile 'FILE ERASE type text/html name '||tempfile 
  return 200' '||extract('bytessent')
end /* do */

if opts.!ADDDESC=3 then do
  call outit '<html><HEAD><TITLE>ThumbNail Index Editor: step 3 of 3 </title>'
  call outit '</head><body>'

  foo=list_inds3(action)
  call outit '</BODY></HTML>'
  call lineout tempfile
  call gofile 'FILE ERASE type text/html name '||tempfile 
  return 200' '||extract('bytessent')
end /* do */

/* list all the directories */
if dodirlist=1 then do        /* create a document to display thumbnails */

  if wordpos('SUPERUSER',translate(privset))+wordpos('THUMBNAIL',translate(privset))=0 then do
      'header add WWW-Authenticate: Basic Realm=<!CREATE_DIRECTORIES_WWWTHUMB>'  /* challenge */
       return sref_response('unauth', "You do not have Directory listing rights ",tempfile,servername)
  end  /* Do */

/* these are used in make_dirlist */
  oof=strip(ddir,,'\')||'\*.*'          
  oof2=sysfiletree(oof,'dirs.','DOS')

  call outit '<html><HEAD><TITLE>Directory listing</title></head>'
  call outit '<script language="javascript">'
  call outit '<!--'
  call outit 'var vstore="/" ;'   
  call outit 'var totdir='dirs.0 ' ;'
  call outit 'var nowdir=0  ;'
  call outit ' '
  call outit 'function do_chosen(thedir,dirnum) {'
  call outit 'window.document.TT.CHOSEN.value=thedir ;'
  call outit ' vstore=thedir ; nowdir=dirnum ;'
  call outit ' return true }'
  call outit ' '
  call outit 'function next_dir() {'
  call outit 'idir=nowdir+1;'
  call outit 'if (idir>totdir) {idir=0}'
  call outit ' '
  call outit 'window.document.TT.CHOSEN.value=dirarray[idir] ;'
  call outit ' vstore=dirarray[idir] ; nowdir=idir ;'
  call outit ' return true }'

  call outit '// end of hiding -->'
  call outit '</script>'


  call outit '<body>'
  call make_dirlist
  call lineout tempfile,"</body></html>"
  call lineout tempfile
  call gofile 'FILE ERASE type text/html name '||tempfile 
  return 200' '||extract('bytessent')
end

/* document to view all thumbnails in a cache */
if opts.!viewem<>'' then do        /* create a document to display thumbnails */
  if is_cgi=0 then do      /* sre-http addon call */
    if wordpos('SUPERUSER',translate(privset))+wordpos('THUMBNAIL',translate(privset))=0 then do
      'header add WWW-Authenticate: Basic Realm=<!View_THUMBNAILS>'  /* challenge */
       return sref_response('unauth', "You do not have ThumbNail viewing rights ",tempfile,servername)
    end  /* Do */
    fixexpire=value(enmadd||'FIX_EXPIRE',,'os2environment')
    fii=value('SREF_PREFIX',,'os2environment')
    if fixexpire>0 & fii='' then  fpp=sref_expire_response(fixexpire,0)

  end           /* no authorization checks if called as a cgi-bin */
  else do               /* cgi-bin call */
    say 'Content-type: text/html'
    say
  end
  call outit '<html><HEAD><TITLE>ThumbNail Viewer </title></head><body>'

  aa=view_thumbs(opts.!viewem,opts.!no_descrip,action,opts.!bigpicture)

  if opts.!gohome=1 then do
    if wwwthumb_sel<>'' then
     call outit '<hr width="30%"> <a href="'||wwwthumb_sel||'">Return to thumbnail creation page </a>'
   else
     call outit '<hr width="30%"> <a href="/Close" onClick="window.close(); return false;">Close Window</a>'
   end 
   else do
     call outit '<hr width="30%"> <a href="/Back" onClick="window.back(-1); return false;">Back</a>'
   end

  call outit '</BODY></HTML>'
  if is_cgi=0 then do
     call lineout tempfile

/* also copy these results to html_file */
     if opts.!index<>'*' &  opts.!html_file<>'' then do  
        ahtml=translate(strip(opts.!html_File),'\','/')
        if abbrev(ahtml,'\')=0 then
            dasel2=strip(strip(dasel),,'\')||'\'||strip(ahtml,,'\')
        else
            dasel2=ahtml
        thefile=sref_do_virtual(ddir,dasel2,enmadd,0,transaction,homedir,host_nickname)
        if stream(thefile,'c','query exists')<>'' then do       /* rename preexisting */
           parse var thefile ttfile '.' .
           ttfile=dostempname(ttfile||'.???')
           foo=dosrename(thefile,ttfile)
           if foo=0 then call pmprintf("WWWThumb Warning: Unable to rename old "thefile)
        end
        foo=doscopy(tempfile,thefile,'R')

       errs.0='Success'
       errs.2='source file not found '
       errs.3='source or target path not found '
       errs.5='target file exists but 'A' or 'R' mode not specified '
       errs.32=' sharing violation for source or target file '
       errs.108=' source or target drive locked '
       errs.112=' disk full '
       errs.206=' invalid source or target file name '
       errs.267=' source name is a directory '
       errs.282=' extended attributes not supported for target '
       if foo<>0 then call pmprintf("WWWTHUMB error copying to "thefile": "errs.foo)

     end
     call gofile 'FILE ERASE type text/html name '||tempfile 
     return 200' '||extract('bytessent')
   end                  /* if srehttp addon */
   exit         /* if cgi, just exit */
end /* do */

/*  FInd a thumbnail, and return it  (or, possibly return one of the
    extension specific defaults) */

/* lookup the selector in an index (or in all the indices */
if opts.!index<>''  then do
   index_list=make_index_list(opts.!index)  /* will return all matching indices */
   islookup=0
   if method='LOOKUP' then islookup=1
   if index_list='' then do
       if islookup=1 then return ' ,'||thumbnail_dir' 'thumbnail_dir_sel   /* no match */
       xx=return_from_cache('',1,islookup)      
   end /* do */
   else do
     do jmm=1 to words(index_list)
        aw=strip(word(index_list,jmm))
        if verbose>3  & is_cgi=0 then say " ThumbNail: checking index " aw
        if jmm=words(index_list) then
           xx=return_from_cache(aw,0,islookup)
        else
           xx=return_from_cache(aw,1,islookup)
        if xx<>'0' then leave
     end
   end

   if xx=0 & is_cgi=0 then do
          'RESPONSE HTTP/1.0 404 No such file'  
          call lineout tempfile, "<body><h2>Thumbnail is at...</h2>"
          call lineout tempfile, "<p>Error: the requested file can not be found:<tt> "opts.!sel'</tt>'
          call lineout tempfile, "</body></html>"
          call lineout tempfile  /* close */
          call gofile  'FILE ERASE TYPE text/html NAME '||tempfile
   end

  if islookup=1 then  do
       if xx='' then return ' ,'||thumbnail_dir' 'thumbnail_dir_sel   /* no match */
       cachedir=translate(strip(thumbnail_dir,'t','\'))
       a1=thumbnail_dir_sel'/'substr(xx,length(cachedir)+2)
       a2=translate(a1,'/','\')
       return a2' 'xx ' ,'||thumbnail_dir' 'thumbnail_dir_sel   
  end
  if is_cgi=0 then do
      if xx=2 then                             
         return 302' '||extract('bytessent')
      else
         return 200' '||extract('bytessent')
  end
  exit                 /* if cgi, just exit */
end /* do */

/* If here, then  create thumbnail on the fly? */
if opts.!sel<>'' then do         /* no selector, so nothing to do */
  if is_Cgi=1 then do           /* takes too long to do it as a cgi-bin script */  
     say 'Content-type: text/html'
     say
     say "<h2>Sorry. Can not create a thumbnail on-the-fly using CGI-BIN</h2>"
     say " Due to the various means by which web servers may resolve selectors "
     say " to filenames, on-the-fly creation of thumbnails is not supported under CGI-BIN.<p>"
     say " You can run create an thumbnail index (that contains the thumbnail for "opts.!sel ")by running WWWThumb.CMD in stand-alond mode, "
     say " or you can run WWWthumb "
     say " as an SRE-http addon (if you are an using the SRE-http WWW server for OS/2)"
     exit
  end /* do */


/* get file to thumbnailize */
   if not_on_the_fly>0 then do      /* on the fly not allowed */
         return '401 0'
   end 
   nconvert=0; nautos=0
   eek1=opts.!sel
   if pos('.',eek1)=0 then eek1=eek1||'/' 
   thefile=sref_do_virtual(ddir,eek1,enmadd,1,transaction,homedir,host_nickname)
   if thefile=0 then do
     call lineout tempfile,'No such selector: 'eek1
     call lineout tempfile
     call gofile  'FILE ERASE type text/plain name '||tempfile 
     return '200 20'
   end 

   call init_params        /* initialize some paramters */
   rr=make_dathumb(,thefile,,tempfile)
   if rr="" then do
     'NODATA'
   end 
   else do
     call gofile  'FILE ERASE type image/gif name '||tempfile 
  end
  return '200 '||extract('bytessent')
end

/* if here, nothing to do */
if is_Cgi=1 then do           /* takes too long to do it as a cgi-bin script */  
     say 'Content-type: text/html'
     say
     say "<h4>No options specified</h4>"
     exit
end 

call lineout tempfile,'No selector specified '
call lineout tempfile
call gofile  'FILE ERASE type text/plain name '||tempfile 

return '200 20'


/*************************************/
/* output to tempfile, or stdout (depending on whether it's called as cgi or srehttp addon*/
outit:
parse arg damess
if is_cgi=1 then
 say damess
else
  call lineout tempfile,damess
return 1


/*************************************/
/* create an html document that views thumbnails. Uses stuff stored
in the thumbnail index file */
view_thumbs:procedure expose opts. thumbnail_dir tempfile thumbnail_dir_sel ,
     imgalign uri is_cgi tdcs. dasel ddir enmadd transaction homedir host_nickname


parse arg ncols,node,action,bigpicture
cachedir=strip(translate(strip(thumbnail_dir,'t','\')))
ncdir=length(cachedir)

index_list=make_index_list(opts.!index)
bigh=strip(decodekeyval(translate(opts.!bigheader,' ','+')))
if bigh<>'' & bigh<>0 & opts.!index<>'*' then  
  nop
else
   call outit '<h2 align=CENTER>Thumbnail viewer </h2>'

if index_list='' then do
  if opts.!index='*' then
    call outit ' <b>Sorry</b>. There are no thumbnail indices available'
  else
    call outit ' <b>Sorry</b>. No such index: <u>'opts.!index'</u>'
  return 1
end /* do */

/* show list of thumbnails? */
bgs.1='#bbccbb'
bgs.2="#ddeedd"
if opts.!index='*' then do
   call outit '<h3>Select a  thumbnail index </h3>'
   if opts.!html_file<>'' then do
      call outit '<center><em>Results will also be written to: '||opts.!html_file||'</em></center>'
   end /* do */
   call outit '<table border=0><tr><th>Thumbnail<br>File</th><th># items</th><th><em>Size of <br>thumbnails</em></th>'
   call outit '<th>Directory <br>(selector) </th> <th>Description</th>'

   do mm=1 to words(index_list)
       aw=word(index_list,mm)
/*       aw2=filespec('n',aw) */
       aw2=translate(substr(aw,ncdir+2),'/','\') /* allow subdirs of cachedir*/
       am1='<a href="'action||'?index='aw2
       am2='&view='ncols'&no_descrip='node'&bigpicture='bigpicture
       am2=am2'&big_m='opts.!big_mess'&clientmap='opts.!big_clientmap
       am2=am2'&big_col='opts.!big_col'&big_row='opts.!big_Row'&viewin='||strip(opts.!vuin)
       if otps.!mapalt<>' ' then am2=am2||'&mapalt='||strip(opts.!mapalt)
       if opts.!HTML_FILE<>'' then am2=am2||'&HTML_FILE='||opts.!html_file
       if bigh<>' ' & bigh<>0 then  am2=am2||'&bigheader='||opts.!bigheader
       ff=pos('.IND',translate(aw2))
       aw3=delstr(aw2,ff)
       am1=am1||am2||'">'aw3'</a>'
       al1=linein(aw) ;foo=stream(aw,'c','close')
       parse  var al1 reclen numrec idlen cshlen dasel awid aht . '/#/' adesc '/#/' .
       kt=1+(mm//2)
       call outit '<tr bgcolor="'||bgs.kt||'"><td>'am1'</td><td>'numrec'</td><td><em>'awid 'x' aht '</em></td>'
        adesc2=sref_replacestrg(adesc,'&','&amp;','ALL')
        adesc2=sref_replacestrg(adesc2,'<','&lt;','ALL')
        adesc2=sref_replacestrg(adesc2,'>','&gt;','ALL')
        adesc2=sref_replacestrg(adesc2,'"','&quot;','ALL')
       call outit '<td>'dasel'</td><td><tt>'adesc2'</tt></td>'
   end /* do */
   call outit '</table><br>'
   call outit ' <b>Or..</b>'
    am1='<a href="'action||'?index=*.IND'
    am2='&view='ncols'&no_descrip='node
    am1=am1||am2||'">Display them all!</a>'
    call outit am1

   return 1
end /* do */

do ii=1 to words(index_list)
  theind=strip(word(index_list,ii))
  afoo=linein(theind) 

  if afoo="" then do
       call outit 'Unable to read index file: 'theind '(try again later) '
       numrec=0
       return 0
  end /* do */

  parse  var afoo reclen numrec idlen cshlen dasel awid aht . '/#/' adesc '/#/' .
  call outit ' '

  if bigh<>'' & bigh<>0 then  do

    tbigh=translate(strip(bigh))
    if pos('$DESC',tbigh)>0 then do
      if tbigh='$DESC' then do
          bigh=adesc
          call outit '<br>'||bigh||'<br>'
      end 
      ELSE DO
        jj=pos('$DESC',tbigh)
      
        abigh=left(bigh,jj-1)
        abigh=abigh||adesc
        goo=substr(bigh,jj+5)
        bigh=abigh||goo
        call outit bigh
      end 
    end
    else do             /* $DESC not found in bigh */
       call outit bigh
    end 
 end                    /* bigh exists */
 else do
   call outit '<!-- ========== ' dasel ' ============= -->'
    call outit '<hr width=40%> <h2>Thumbnails of files in 'dasel '</h2>'
    call outit '<blockquote>'adesc'</blockquote>'
    call outit '<!--  Total of 'numrec ' thumbnails -->'
    call outit '<!-- using the 'theind 'thumbnail-index -->'
 end

/* this is sort of  deprecated by the html_file option */
  if is_cgi=0 & bigpicture=1 then do      /* an sre specific option, used w/ clientside imagemaps */
  if opts.!mapalt=1 | abbrev(strip(translate(opts.!mapalt)),'Y')=1 then do
      turi=translate(uri)
      foof=pos('BIGPICTURE=',turi)
      if foof>0 then do  
          uri2=left(uri,foof-1)||'BIGPICTURE=0'
          foof2=pos("&",turi,foof)
          if foof2>0 then do
             uri2=uri2||substr(uri,foof2)
          end 
      end
      else do
         uri2=uri||'&BIGPICTURE=0'
      end /* do */
      call outit '<a href="'uri2'"><em>Display an expanded list?</em></a><p>'
  end
  end

/* make big pictures of the thumbnails */
  if bigpicture=1 then do
     x32=awid; y32=aht
     oof=filespec('d',theind)||filespec('p',theind)
     ncdir=length(cachedir)
     cdir2=strip(strip(translate(substr(oof,ncdir+2),'\','/'),,'\'))
     call make_bigpicture cdir2
     iterate
  end /* do */

/* return a table, each cell a seperate IMG */


  ifnd=0
  if ncols=1 then 
      call outit '<Ol> '
  else
     call outit '<table cellpadding=0 rules="NONE" COLS="'||(2*ncols)||'"> '

  if opts.!VUIN=1 | abbrev(translate(strip(opts.!VUIN)),'Y')=1 then
      vuin=' TARGET="VIEWIN" '
  else
     vuin=' '
/* make linke to thumbnail and actual file-- all entries in theind */
  do mm=1 to numrec
     aa=linein(theind)
     parse var aa afilename acachename . amess ; filename=strip(filename)

     if is_cgi=0 & pos(':',afilename)=0 then
       filename=sref_do_virtual(ddir,afilename,enmadd,0,transaction,homedir,host_nickname)
    else
       filename=afilename

     if stream(filename,'c','query exists')='' then iterate
     ifnd=ifnd+1
     selname=strip(translate(substr(filename,cshlen+1),'/','\'),,'/')

     selname0=selname
     dasel=strip(strip(dasel),,'/')
     if dasel='' then
        selname='/'selname
     else
        selname='/'dasel'/'selname
     if thumbnail_dir_sel<>' '& thumbnail_dir_sel<>0 then do  
       aa=strip(thumbnail_dir_sel,,'/')
       if pos(':',acachename)>0 then
          aa='/'aa'/'||translate(substr(acachename,length(cachedir)+2),'/','\')
       else
          aa='/'aa'/'||strip(acachename,,'/')
        
       alink7='<img  align="'||imgalign||'"  width='||awid||' height='||aht||' src="'||aa||'"'
       parse value filespec('n',filename) with isalt '.' .
       alink7=alink7||' alt="'||isalt||'">'
     end /* do */
     else do
       alink7='<img align="'imgalign'" width='awid ' height='aht ' src="/'action'?'selname'&index='opts.!index'"'
       parse value filespec('n',filename) with isalt '.' .
       alink7=alink7||' alt="'||isalt||'">'
     end
     amess2=''
     if amess<>'' & node<>1 then amess2=' <em>('amess')</em>'
     alink8='<a href="'selname||'"'||vuin||'>'alink7'</a> '
     cmess=strip(subword(amess,2))
     cspan=''
     if cmess=' ' then cspan="COLSPAN=2"
      call outit '<li> 'alink8 || '<em>'||word(amess,1)||'</em> &nbsp; &nbsp; '||cmess
   end          /* get next entry in index_list */

  call outit '</ol>'
  call outit '<p>'       /* get from next index */
end             /* get nextindex_list */

call outit ' '
call outit '<!-- Save this document, edit it, and use it as an index -->'

return 1

/*************************************/
/* create an html document that views thumbnails. Uses stuff stored
in the cache index file */
list_inds:procedure expose opts. thumbnail_dir tempfile thumbnail_dir_sel ,
     imgalign uri is_cgi tdcs. dasel
parse arg action
cachedir=translate(strip(thumbnail_dir,'t','\'))
ncdir=length(cachedir)
index_list=make_index_list(opts.!index)

call outit '<h2 align="CENTER">Thumbnail Description Editor </h2>'

if index_list='' then do
  if opts.!index='*' then
    call outit ' <b>Sorry</b>. There are no thumbnail indices available'
  else
    call outit ' <b>Sorry</b>. No such index: <u>'opts.!index'</u>'
  return 1
end /* do */

/* show list of thumbnails? */
bgs.1='#bbccbb'
bgs.2="#ddeedd"
   call outit '<h3>Select a  thumbnail index </h3>'
   call outit '<table border=0><tr><th>Thumbnail<br>File</th><th># items</th><th><em>Size of <br>thumbnails</em></th>'
   call outit '<th>Directory <br>(selector) </th> <th>Description</th>'

   do mm=1 to words(index_list)
       aw=word(index_list,mm)
/*       aw2=filespec('n',aw) */
       aw2=translate(substr(aw,ncdir+2),'/','\') /* allow subdirs of cachedir*/

       ff=pos('.IND',translate(aw2))
       aw3=delstr(aw2,ff)
       am1="<a href="action"?index="aw3"&ADDDESC=2>"aw3"</a>"
       al1=linein(aw) ;foo=stream(aw,'c','close')
       parse  var al1 reclen numrec idlen cshlen dasel awid aht . '/#/' adesc '/#/' .
       kt=1+(mm//2)
       call outit '<tr bgcolor="'||bgs.kt||'"><td>'am1'</td><td>'numrec'</td><td><em>'awid 'x' aht '</em></td>'
        adesc2=sref_replacestrg(adesc,'&','&amp;','ALL')
        adesc2=sref_replacestrg(adesc2,'<','&lt;','ALL')
        adesc2=sref_replacestrg(adesc2,'>','&gt;','ALL')
        adesc2=sref_replacestrg(adesc2,'"','&quot;','ALL')
       call outit '<td>'dasel'</td><td><tt>'adesc2'</tt></td>'
   end /* do */
   call outit '</table><br>'

   call outit '</body></html>' 
   return 1

/*************************************/
/* list entries in a thumbnail index */
list_inds2:procedure expose opts. thumbnail_dir tempfile thumbnail_dir_sel ,
     imgalign uri is_cgi tdcs. dasel ,
     ddir enmadd transaction homedir host_nickname

parse arg action
cachedir=translate(strip(thumbnail_dir,'t','\'))
theind=strip(make_index_list(opts.!index))
if words(theind)<>1 then do
   call outit "Error: bad index list (in list-entries): "index_list
   return 1
end 

afoo=linein(theind) 
if afoo="" then do
    call outit 'Unable to read index file: 'theind '(try again later) '
    return 0
end 

parse  var afoo reclen numrec idlen cshlen dasel awid aht . '/#/' adesc '/#/' .
call outit ' '

call outit '<!-- ========== ' dasel' ============= -->'
call outit '<hr width=40%> <h2>Thumbnails of files in  'dasel '</h2>'

call outit  '<Form method='POST' action="WWWTHUMB.CMD">'
call outit '<input type="hidden" name="ADDDESC" value=3>'
call outit '<input type="hidden" name="INDEX" value="'OPTS.!INDEX'">'

call outit '<table bgcolor="#bbccbb" ><tr><td><em>Index Description<em>:</td>'
call outit '<td><input type="text" name="DESC" value="'adesc'" size=40></td></table>'
call outit '<!--  Total of 'numrec ' thumbnails -->'
call outit '<!-- using the 'theind 'thumbnail-index -->'


call outit '<Ol> '
ifnd=0
do mm=1 to numrec
     aa=linein(theind)
     parse var aa afilename acachename . amess ; filename=strip(filename)

     if is_cgi=0 & pos(':',afilename)=0 then
       filename=sref_do_virtual(ddir,afilename,enmadd,0,transaction,homedir,host_nickname)
    else
       filename=afilename

     if stream(filename,'c','query exists')='' then iterate
     ifnd=ifnd+1
     selname=strip(translate(substr(filename,cshlen+1),'/','\'),,'/')
     selname0=selname
     dasel=strip(strip(dasel),,'/')
     if dasel='' then
        selname='/'selname
     else
        selname='/'dasel'/'selname
     aa=strip(thumbnail_dir_sel,,'/')
     if pos(':',acachename)>0 then
          aa='/'aa'/'||translate(substr(acachename,length(cachedir)+2),'/','\')
     else
          aa='/'aa'/'||strip(acachename,,'/')

     parse value filespec('n',filename) with isalt '.' .
     alink7='<a href="'selname'" target="FILE_VIEWER">'selname'</a>'
     alink8=' (<a href="'aa'" target="THUMB_VIEWER">thumbnail</a>)'
     cmess=strip(subword(amess,2))
     call outit '<li> 'alink7 ||alink8'<br> <em>First description:</em><tt> '||word(amess,1)||'</tt>'
     call outit '<br><table><tr><td><em>2nd description:</em></td> '

     adesc2=sref_replacestrg(cmess,'&','&amp;','ALL')
     adesc2=sref_replacestrg(adesc2,'<','&lt;','ALL')
     adesc2=sref_replacestrg(adesc2,'>','&gt;','ALL')
     adesc2=sref_replacestrg(adesc2,'"','&quot;','ALL')
     call outit '<td><textarea cols=50 rows=2 name="LINEDESC.'||mm||'">'||adesc2||'</textarea></td></table>'

   end          /* get next entry in index_list */

   call outit '</ol><input type="submit" value="Change descriptions">'
   call outit '<input type="reset" value="Reset"></form>'

   return 1


/*************************************/
/* list entries in a thumbnail index */
list_inds3:procedure expose opts. thumbnail_dir tempfile thumbnail_dir_sel ,
      imgalign uri is_cgi tdcs. dasel list1 ,
      ddir enmadd transaction homedir host_nickname


parse arg action 
theind=''
linedesc.=''
/* parse out the linedesc. arguments */
DO UNTIL LIST1=''
   parse var list1 a1 '&' list1
   PARSE VAR a1 avar '=' aval
   Avar=translate(STRIP(Avar))
   Aval=strip(decodekeyval(translate(aval,' ','+')))
   if abbrev(avar,'LINEDESC.')=1 & aval<>'' then do
      parse var avar . '.' nth
      linedesc.nth=aval
   end 
end  

cachedir=translate(strip(thumbnail_dir,'t','\'))
theind=strip(make_index_list(opts.!index))
if words(theind)<>1 then do
   call outit "<tt>Error: bad index list:</tt> "index_list
   return 1
end 

afoo=linein(theind) 
if afoo="" then do
    call outit '<tt>Unable to read index file</tt>: 'theind '(try again later) '
    return 0
end 
crlf='0d0a'x
parse  var afoo reclen numrec idlen cshlen dasel awid aht woogie '/#/' adesc '/#/' gooba
bigstring=''
if opts.!desc='' then do
   bigstring=afoo||crlf
end 
else do
   bigstring=reclen' 'numrec' 'idlen' 'cshlen' 'dasel' 'awid' 'aht' 'woogie' /#/'||opts.!desc||'/#/ '||gooba||crlf
end 

call outit '# Items in 'opts.!index' = <tt>'numrec'</tt>'
call outit '<table>'
ifnd=0
bgs.0='#bbccbb'
bgs.1="#ccdddd"
ichanged=0
do ii=1 to numrec
    aa=linein(theind)

   if linedesc.ii='' then do
       bigstring=bigstring||aa||crlf
       iterate
   end 
   parse var aa bfilename cachename dw mess1 amess ; filename=strip(filename)

   if is_cgi=0 & pos(':',bfilename)=0 then
       filename=sref_do_virtual(ddir,bfilename,enmadd,0,transaction,homedir,host_nickname)
   else
       filename=bfilename

   if stream(filename,'c','query exists')='' then do
        call outit '<tr><td><tt>Warning. No such file</td><td>:</tt>'filename'</td>'
        bigstring=bigstring||aa||crlf
        iterate
   end 
   linedesc.ii=strip(translate(linedesc.ii,' ','0d0a0009'x))

   if linedesc.ii=strip(amess) then do
       bigstring=bigstring||aa||crlf
       iterate
   end
   ichanged=ichanged+1
   ifnd=1-ifnd
   selname=strip(translate(substr(filename,cshlen+1),'/','\'),,'/')
   dasel=strip(strip(dasel),,'/')
   if dasel='' then
        selname='/'selname
   else
       selname='/'dasel'/'selname
   call outit '<tr bgcolor="'bgs.ifnd'"><td>#'ii': <tt>'selname'</tt></td> '
   call outit '<td>: <em>'amess'</em><hr width="20%"> 'linedesc.ii'</td>'
   bigstring=bigstring||filename' 'cachename' 'dw' 'mess1' '||linedesc.ii||crlf

end 
call outit '</table>'

if ichanged=0 then do
        call outit '<p><B>No changes to</b><tt> 'theind'</tt>'
        call outit '<p><a href="javascript:history.go(-2)">Back.. </a>'
        return 1
end 

parse var theind ttfile '.' .
ttfile=dostempname(ttfile||'.???')
foo=stream(theind,'c','close')
foo=dosrename(theind,ttfile)
if foo=0 then do
   call outit '<p><b>ERROR:</b> unable to rename old index file 'theind
   call outit '       to 'ttfile
   return 0
end
call outit '<p>Old index file renamed to <tt>'ttfile'</tt>'
foo=stream(theind,'c','open write')
if abbrev(translate(foo),'READY')<>1 then do
  call outit '<p><b>Error</b>: Unable to write new contents of index file 'theind
  return
end
foo=charout(theind,bigstring,1)
if foo<>0 then do
   call outit '<p><b>Warning:</b> 'foo' bytes not written to 'theind
end 
else do
   call outit '<p>Success writing <tt>'theind'</tt>'
end 
foo=stream(theind,'c','close')

call outit '<p><a href="javascript:history.go(-2)">Back.. </a>'
call outit '  or <a href="javascript:close()">Close </a>'


return 1



/*****************/
/* make a list of indices to look in (* wildcards are resolved)
  return space delimited list of fully qualified files  */
make_index_list:procedure expose thumbnail_dir verbose

parse arg alist
alist=decodekeyval(translate(alist,' ','+'))
cachedir=translate(strip(thumbnail_dir,'t','\'))

dalist=''
nl=words(alist)
do ll=1 to nl
   aw=strip(word(alist,ll))
/* get index */
   theind=cachedir||'\'aw
   if pos('.IND',translate(theind))=0 then theind=theind'.IND'
   yikes=sysfiletree(theind,gotfs,'OS')
   do ir=1 to gotfs.0
      dalist=dalist' 'gotfs.ir
   end /* do */
end
return dalist


/*************************************/
/* return the 'cached image'. 0=error, 1=http 200, 2=http 302 */
return_from_cache:procedure expose opts. thumbnail_dir img_dir defaults. ,
                        enmadd homedir host_nickname transaction ddir ,
                        thumbnail_dir_sel servername verbose opts. is_cgi
parse arg theind,more_indices,islookup


/* get file to thumbnailize */
eek1=opts.!sel
cachedir=translate(strip(thumbnail_dir,'t','\'))

from_default=0

if is_cgi=0 then do
  if pos('.',eek1)=0 then eek1=eek1||'/' 
  thefile=sref_do_virtual(ddir,eek1,enmadd,1,transaction,homedir,host_nickname)
  if thefile=0 then return 0    /* no such file */
  imgdir=img_dir
  if imgdir='' then imgdir=cachedir
  imgdir=strip(imgdir,'t','\')

/* bad index, or bad filename */
   if thefile=0 | theind="" then do
      if islookup=1 then return ''   /* don't check default if lookup call */
      thefile=match_defaults(opts.!sel,imgdir)  /* something should almost ALWAYS be returned */
      if thefile='' then /* but just in case, or if not_on_the_fly=2 ... */
        'NODATA'
      else
        call gofile  'FILE type image/gif nocache name '||thefile
     return 1
   end
end /* do */

/* search the cache ... */
  
  afoo=linein(theind) 
  parse  var afoo reclen numrec idlen cshlen dasel .
  if is_cgi=1  then do          /* convert selector to file name */
     dasel=strip('/'||strip(dasel,,'/'))
     issel=strip('/'||strip(opts.!sel,,'/'))
     yeek=linein(theind)
     parse var yeek zfile . ; 
     zfile=left(zfile,cshlen) ; zfile=strip(zfile,,'\')
     qfile=translate(substr(issel,length(dasel)+1),'\','/')
     qfile=strip(qfile,,'\')
     thefile=zfile'\'qfile
  end /* is cgi */

  foo=stream(theind,'c','close')
  aa=search_fixed(thefile,theind,numrec,reclen+2,1,1,idlen,0)
  if aa="" then do
      cachename=''
  end /* no cache match */
  else do
     aa=translate(aa,' ','0d0a'x)
     parse var aa filename cachename cachedate .
     yerf=date_match(filename,cachedate)
     if yerf<>0 then
        cachename=''
      else
        cachename=stream(cachename,'c','query exists')
  end /* do */

  if  islookup=1 then return cachename /* don't do defaults */

  if cachename='' & more_indices=1 then return 0  /* no match in this index, try another */

  if cachename=''  & is_cgi=0 then do       /* try using a default */
    cachename=match_defaults(opts.!sel,imgdir)  /* something should ALWAYS be returned */
    if cachename<>"" then from_default=1
  end

/* and return the result */
  if cachename='' then do
       if is_cgi=1 then do
          say 'Content-type: image/gif '
          say
       end
       else do
         'NODATA'
       end
   end
   else do
      if  is_cgi=1 | thumbnail_dir_sel='' | thumbnail_dir_sel=0 | from_default=1 then do
        if is_cgi=0 then do
           call gofile  'FILE type image/gif nocache name '||cachename
        end
        else do
           foo=stream(cachename,'c','open read')
           a=charin(cachename,1,chars(cachename))
           foo=stream(cachename,'c','close')
           say 'Content-type: image/gif '
           say 
           call charout,a
        end /* do */
      end
      else do           /* redirect to the thumbnail */
          a1=thumbnail_dir_sel'/'substr(cachename,length(cachedir)+2)
          a2=translate(a1,'/','\')
          wow=moved(a2,filespec('n',theind))
          return 2
      end 
   end
   return 1


/* ----------------------------------------------------------------------- */
/* MOVED: Return a 'moved' response  -- it calls a macrospace routine      */
/* ----------------------------------------------------------------------- */
/* Argument is new URL or partial URI          */

moved:procedure expose stempfile   verbose   servername 

  parse arg uri,daind
  port=extract('port')
  if left(translate(uri),5)=='HTTP:' then do /* got full URI */ 
         url=uri
   end
   else  do
      if port=80 then pp=''; else pp=':'port
      url='http://'servername||pp'/'uri        /* relocation */
  end
  call lineout tempfile, '<!doctype html public "-//IETF//DTD HTML 2.0//EN">'
  call lineout tempfile, "<html><head><title>Moved</title></head>"

  /* Now set the response and build the response file */
    'RESPONSE HTTP/1.0 302 Moved Temporarily'  /* Set HTTP response line */
    'HEADER ADD Location:' url
    call lineout tempfile, "<body><h2>Thumbnail is at...</h2>"
    call lineout tempfile, "<p>The thumbnail is <a href="""url""">here</a>"
    parse value filespec('n',daind) with  daind '.' .
    call lineout tempfile,'<em>(from thumbnail index: 'daind')</em><br>'
    call lineout tempfile, "</body></html>"
  
  call lineout tempfile  /* close */
 call gofile  'FILE ERASE TYPE text/html NAME '||tempfile
return 1



/*************************************/
/* match a default -- use DEFAULTS. list */
match_defaults:procedure expose defaults. not_on_the_fly
parse upper arg lookfile,imgdir

if not_on_the_fly=2 then return ''   /* defaults suppressed? */

do mm=1 to defaults.0
   nw=words(defaults.mm)
   afile=translate(strip(word(defaults.mm,nw)))
   if pos(':',afile)=0 & left(afile,1)<>'\' then afile=imgdir'\'afile
   if stream(afile,'c','query exists')='' then iterate /*no such default thumbnail*/
   do mm2=1 to nw-1
       apattern=strip(word(defaults.mm,mm2))
       dam=wild_match(lookfile,apattern)
       if dam<>"0" then return afile
   end /* do */
end /* do */
return ''               /* no match found */


/*************************************/
/* create/view-list-of thumbnails */
from_request:procedure expose thumbnail_dir thumbnail_size text_color text_bcolor,
                       text_height text_width gif_exts opts. pad_with ,
                      x32 y32 doconvert r_back g_back b_back  action ,
                     ddir homedir transparent host_nickname enmadd  wwwthumb_sel,
                      r_Text g_text b_text h10 wtxt verbose thumbnail_dir_sel how_scale

parse arg is13
crlf='0d0a'x
call init_params        /* initialize some paramters */
cachedir=translate(strip(thumbnail_dir,'t','\'))
if dir_exists(cachedir)<>1 then do
    aa= crlf"<b>ERROR</b>: no such directory for caching: "thumbnail_dir
    call govar  aa 
    return 0
end /* do */


if opts.!dosub=1 then  /* process subdirectories ? */
  ts='TS'
else 
 ts='T'

/* process possible multiple directories or files */
do tt=1 to words(opts.!sel)
  eek1=strip(word(opts.!sel,tt))
  dsel=eek1                     /* used in index */
  if pos('.',eek1)=0 then eek1=eek1||'/' 
  thedir=sref_do_virtual(ddir,eek1,enmadd,0,transaction,homedir,host_nickname)
  thedir=strip(thedir,'t','\')
  if dir_exists(thedir)<>1 then do
      aa=crlf||'<B> No such directory </b>: ' eek1
      call govar  aa
      return 1
  end /* do */
  aa='0d0a'x||'<h2>Thumbnails in ' eek1 ' </h2>'
  call govar  aa
  call from_request2 1
end /* do */
call govar '<hr width="35%">'
if wwwthumb_sel<>'' then 
  aa='<hr> <a href="'||wwwthumb_sel||'">Back to thumbnail creation page </a>'
else
  aa='<hr width="30%"> <a href="/Close" onClick="window.close(); return false;">Close Window</a>'
call govar aa


return 1

/********/
/* working portion of from_request */
from_request2:          
actualnum=sysfiletree2(thedir'\*.*',ts,opts.!inclusion,length(thedir))

isucc=0 ;nautos=0;nconvert=0
inactive=extract('limittimeinactive')/2
aa=crlf"<h3>Examining " flist.0 " files from " thedir '</h3>'
if actualnum<>flist.0 then 
  aa=aa'<b>Note:</b> 'actualnum ' files before use of inclusion list of: <tt>'opts.!inclusion'</tt>'
call govar  aa
write_transparent=opts.!write_transparent 
autogif=opts.!autogif
write_gif_size=opts.!write_gif_size
write_transparent=opts.!write_transparent
foo=time('r')

/* index file (to create */
if pos(":",opts.!Index)>0 then do
   aa='<p><B>Error:</b> Index not permitted: 'opts.!Index'<br>(it must be relative to thumbnail cache directory)</em>)'
   call govar  aa
   return 0
end

if opts.!index=' ' | opts.!index=0 then do
  aa=translate(eek1,' ','\/')
  parse var aa aa2 '.' .
  tmp1=word(aa2,words(aa2))
  tfile=mk_filename(cachedir'\'||tmp1,'.IND')
end
else do
  tfile=strip(translate(strip(opts.!index),'\','/'),'l','\')
  parse var tfile tfile '.' .
  tfile=tfile||'.IND'
  tfile=cachedir'\'tfile       /*MUST be relative to cachedir */
  if stream(tfile,'c','query exists')<>' ' then do
     aa=crlf'<p><b>ERROR: </B> A thumbnail index of 'opts.!Index ' already exists.'
     call govar  aa
     return 0
  end /* do */
end

foo=strip(filespec('d',tfile)||filespec('p',tfile),'t','\')
if dosisdir(foo)=0 then do
  oy=sysmkdir(foo)
  if oy=0 then do
     aa='<p><B>Creating directory: </b> <tt>'foo'</tt>'
     call govar  aa
  end
  else do
     aa='<p><B>Error 'oy'.</b> Unable to create directory: <tt>'foo'</tt>'
     call govar  aa
     return 0
  end 
end 
cachedir_use=foo

iwasx=0
do m=1 to flist.0
   aw=flist.m
   parse upper var aw adate asize . dafile ; dafile=strip(dafile)
   if m//25=1 | time('e')>inactive then  do
        aa=crlf'<br> '  isucc " thumbnails from   "m ' files '
        call govar  aa
       if verbose>3 then say aa
       foo=time('r')
   end
   if stream(dafile,'c','query exists')='' then iterate
   rr=make_dathumb(cachedir_use,dafile,adate,,pad_with)
   if rr<>'' then do
      isucc=isucc+1
      suclist.isucc=rr
   end /* do */
end /* check all files do */

if isucc=0 then do
   aa=crlf'<b>No thumbnails created </b>'
   call govar  aa
    return 0
end /* do */

aa=crlf'<br>' isucc ' thumbnails  created ('nautos '.GIF generated, 'nconvert ' resized) from  ' flist.0 " files"
call govar aa


suclist.0=isucc

oo=arraysort2(suclist)
mxlenv1=0 ; mxlenv2=0
do mm=1 to suclist.0
   parse var suclist.mm v1 v2
   mxlenv1=max(mxlenv1,length(v1))
   mxlenv2=max(mxlenv2,length(v2))
end
do mm=1 to suclist.0
   parse var suclist.mm v1 v2
   suclist.mm=left(v1,mxlenv1)' 'left(v2,mxlenv2)
end /* do */
mxlen=mxlenv1+mxlenv2+1
desc1=opts.!desc
if desc1=0 then desc1=' '
suclist2.1=mxlen' 'suclist.0' 'mxlenv1' 'length(thedir) ' ' dsel' 'x32' 'y32' /#/ 'desc1 ' /#/  ; DO NOT modify '
if length(suclist2.1)>mxlen then mxlen=length(suclist.2)
suclist2.1=left(suclist2.1,mxlen)
do mm=1 to suclist.0
    mm1=mm+1
    suclist2.mm1=suclist.mm
end /* do */
suclist2.0=suclist.0+1
aa=filewrite(tfile,suclist2)
if aa=0 then do
   aa='<p><B>ERROR. </b> Unable to write index to 'tfile
   call govar aa
   return 0
end /* do */

tfile2=substr(tfile,length(cachedir)+2)
parse var tfile2 tfile2 '.' .
aa=crlf' <p> ' isucc " thumbnails written to " thumbnail_dir
aa=aa||crlf||" <p>Index of these thumbnails is:<b> " tfile2 '</b>&nbsp; &nbsp;('tfile ')'
call govar aa
aa='<hr> <a href="'action'?index='tfile2'&view=3&GOHOME=1">View thumbnails in 'tfile2 '</a>'
call govar aa


return 1


/************/
/* to a "VAR xx or sref_multi_send */
govar:
parse arg aa2
if is13='' then DO
   'VAR NAME aa2'
END
else DO
   foo=sref_multi_send(aa2)
   IF FOO<0 THEN EXIT      /* CLIENT CLOSED CONNECTION */
return 0


/*******************/
/* sysfiletree, with check against inclusion list  -- return in flist. */
sysfiletree2:procedure expose flist.
parse upper arg lookat,ts,inclu,lenlookat
inclu=strip(inclu)
aa=sysfiletree(lookat,flist,ts)
if ts.0=0 | inclu='' | inclu=0 | inclu='*'  then return flist.0


ini=words(inclu)                /* put inclusion entries into a stem var */
do ll=1 to ini
   inclus.ll=strip(word(inclu,ll))
end /* do */
inclus.0=ini

mm2=0
do mm=1 to flist.0              /* check each file agains inclusion list */
   aw=flist.mm
   parse upper var aw . . . dafile ; dafile=substr(strip(dafile),lenlookat+2)
   do ip=1 to inclus.0

      arf=wild_match(dafile,inclus.ip)

      if arf<>0 then do

         mm2=mm2+1 ; flist.mm2=flist.mm
      end /* do */
   end /* do */
end
flist.0=mm2
return mm



/*************************************/
/* create/view-list-of thumbnails */
from_keyboard:procedure expose thumbnail_dir thumbnail_size text_color text_bcolor,
                              text_height text_width gif_exts pad_with ,
                      x32 y32 doconvert r_back g_back b_back thedir inclusion ,
                      r_Text g_text b_text h10 wtxt opts. img_dir defaults. thumbnail_dir_sel ,


call init_params        /* initialize some paramters */

ansion=checkansi()
if ansion=1 then do
  aesc='1B'x
  cy_ye=aesc||'[37;46;m'
  normal=aesc||'[0;m'
  bold=aesc||'[1;m'
  re_wh=aesc||'[31;47;m'
  reverse=aesc||'[7;m'
end
else do
  say " Warning: Could not detect ANSI....  output will look ugly ! "
  cy_ye="" ; normal="" ; bold="" ;re_wh="" ;
  reverse=""
end  /* Do */

cls

call lineout, bold cy_ye
call lineout, "This is the WWWthumb faciltity: stand alone mode "
call lineout, normal
call lineout,' Using thumbnail directory: 'bold thumbnail_dir normal
call lineout,'  with equivalent selector: 'bold thumbnail_dir_sel normal
call lineout,' '

getans:
say cy_ye "Select an option: " normal
say bold '    '"?"normal")Short description "
say bold '    '"M"normal")Make thumbnails (store in a thumbnail index)"
say bold '    '"S"normal")Search for a thumbnail "
say bold '    '"X"normal")Exit "
call charout,' Select from above (S,M,X, or ?)'
pull anans ; say
anans=left(anans,1)

select
   when anans='?' then do
      call show_description
   end
   when anans='S' then do
        call getnail
        call check_for_tnail
   end /* do */
   when anans='M' then do
        call getnail
        call create_a_cache
   end
   when anans='X' then exit
   otherwise nop
end  /* select */
signal getans


/***************/
show_description:
      say cy_ye '       ______________________________ ' normal
say bold "WWWthumb "normal " is used to deliver thumbnail images to a "
say "WWW client. Although these thumbnails can be created on-the-fly, "
say "it is much more efficient to create the thumbnails, cache them,"
say "create and index linking the thumbnail to the underlying file, "
say "and retrieve the appropriate thumbnail (using this cache & index) "
say "when needed."
say 
say "You can use this standalone mode of WWWthumb to create such indices."
say "Or, you can  lookup a 'cached' thumbnail (in an already created index)."
      say cy_ye '       ______________________________ ' normal
say
signal getans
end


/*******************************/
/* create a thumbnail index, using keyboard input */
create_a_cache:
dir1:

isverbose=1 ; 
autogif=1 ; check_defaults=1
write_gif_size=0 ;dosub=0
opts.!sel=''
inclusion=''

dir1a: 

say cy_ye " Create thumbnails of files in a selected directory. " normal
thedir=get_string("Enter a fully-qualified-directory. ",thedir)

if dir_exists(thedir)<>1 then do        /* valid directory ? */
   say " no such dir: " thedir
   signal dir1
end /* do */

if pos(':',thedir)=0 then do
   arf=directory()
   thedir=left(arf,2)||thedir
   Say "Using: " thedir
end /* do */

getselector:
foo=pos('WWW\',translate(thedir))
defsel=opts.!sel
if foo>0 & opts.!sel='' then  defsel=translate(substr(thedir,foo+3),'/','\')
say "  ... Selector that points to  "thedir
call charout,bold"      or ? "normal"for help, ENTER="reverse||defsel||normal": "
parse pull opts.!sel
if opts.!sel='' then opts.!sel=defsel
if opts.!sel='?' then do
   say 
   say "When WWWthumb.CMD is called (say, as a CGI-BIN script), it will be "
   say "provided a filename that is expressed relative to your WWW directories. "
   say "In order to match this WWW-filename to an OS/2 filename, the selector "
   say "that points to "thedir" must be provided."
   say
   say "For example, if you want to create thumbnails of all files in"
   say "D:\WWW\IMAGES\ANIMALS; and D:\WWW is the root of your web tree, "
   say "then you should enter /IMAGES/ANIMALS"
   say
   signal getselector
end /* do */
if opts.!sel=0 then opts.!sel=''

getstuff=yesno('Set parameters (N=use defaults)')

say 
if getstuff=1 then do
   call getparams
end /* do */

call show_params
ok=yesno(" Ready to run (N to reenter parameters) ")
if ok=0 then signal dir1a


if dosub=1 then
  ts='TS'
else 
 ts='T'

aa=sysfiletree2(thedir'\*.*',ts,inclusion,length(thedir))

isucc=0 ;nautos=0;nconvert=0
say "Examining " flist.0 " files from " thedir
if aa<>flist.0 then
if actualnum<>flist.0 then 
  say actualnum ' files before use of inclusion list '
isstop=0
iwasx=0
do m=1 to flist.0
   if c2d(isstop)=27 then do
       say "Thumbnail creation aborted after " m " files. Index will NOT be written"
       return 1
   end /* do */

   aw=flist.m
   parse upper var aw adate asize . dafile ; dafile=strip(dafile)
   if stream(dafile,'c','query exists')='' then iterate
   if verbose=1 then say " Making thumbnail for "dafile
   rr=make_dathumb(,dafile,adate,,pad_with,isverbose)
   mrem=flist.0-m
   if m//25=1 then say isucc " thumbnails from   "m ' files; 'mrem' remaining (ESC to stop)' 
   isstop=inkey('n')

   if rr<>'' then do
      isucc=isucc+1
      suclist.isucc=rr
   end /* do */
   else do
      if check_defaults=1 then do         /* get the default file */
          if isverbose=1 then say "   ... checking defaults "
          dfile=match_defaults(dafile,img_dir)
          if dfile<>'' then do  /* copy this file to cachedir */
              dd1=filespec('n',dfile)
              dd1=cachedir'\'dd1
              foo=doscopy(dfile,dd1)
              isucc=isucc+1
              suclist.isucc=dafile' 'dd1' 'adate
             if isverbose=1 then say "   ... using a default for " dafile
          end /* do */
      end /* do */
   end /* do */
end /* check all files do */

if isucc=0 then do
   say "No thumbnails created "
   return 1
end /* do */

say isucc ' thumbnails  created ('nautos '.GIF generated, 'nconvert ' resized) from  ' flist.0 " files"
say

tfile=mk_filename(cachedir'\THUM','.IND')
tfile1=mk_filename(cachedir'\THUM','.TN1')
tfile2=mk_filename(cachedir'\THUM','.TN2')

suclist.0=isucc

oo=arraysort2(tfile,tfile1,tfile2)
mxlenv1=0 ; mxlenv2=0
do mm=1 to suclist.0
   parse var suclist.mm v1 v2
   mxlenv1=max(mxlenv1,length(v1))
   mxlenv2=max(mxlenv2,length(v2))
end
do mm=1 to suclist.0
   parse var suclist.mm v1 v2
   suclist.mm=left(v1,mxlenv1)' 'left(v2,mxlenv2)
end /* do */
mxlen=mxlenv1+mxlenv2+1
desc1=opts.!desc
if desc1=0 then desc1=' '
suclist2.1=mxlen' 'suclist.0' 'mxlenv1' 'length(thedir) ' ' opts.!sel' 'x32' 'y32' /#/ 'desc1 ' /#/  ; DO NOT modify '

if length(suclist2.1)>mxlen then mxlen=length(suclist.2)
suclist2.1=left(suclist2.1,mxlen)
do mm=1 to suclist.0
    mm1=mm+1
    suclist2.mm1=suclist.mm
end /* do */
suclist2.0=suclist.0+1
aa=filewrite(tfile,suclist2)

say isucc " thumbnails written to " thumbnail_dir
say "Index of these thumbnails is: " tfile
say

return 1

/**************/
/* Review parameters */
show_params:
say  '                 'cy_ye'----------' normal                       
if dosub=1 then 
  say bold "Examining (subdirectories also): "normal thedir
else
  say bold "Examining: "normal thedir

if inclusion<>'' then say bold "    using inclusion rules: "normal inclusion
say bold "     and a selector of: " normal opts.!sel
say     "(if no match ...)" bold" Use defaults= "normal check_Defaults 
say      '            'bold' Create thumbnail from .GIF='normal autogif
if autogif=1 then
say bold "Thumbnail size: "normal thumbnail_size
if write_gif_size=0 then do
   say bold " Not "normal " writing Width x Height dimensions on thumbnail "
end /* do */
else do
   if write_gif_size=1 then  
      say   bold "Overlay dimensions on thumbnail, using: "normal
   else
      say   bold "Write dimensions beneath thumbnail, using: "normal
   say        "      width & height : " text_width text_height
   say        "      color and background color: " text_color text_bcolor
   say        "      Background is transparent= " write_transparent
end
say bold "Padding string:"normal reverse||Pad_with||normal
say bold "Verbose= "normal isverbose
say  '                 'cy_ye'----------' normal                       

return 1


/*********/
/* get parameters */
getparams:


dosub=yesno('  Check subdirectories of 'thedir':')
check_defaults=yesno('  Use default "icons" (if no thumbnail available)')

thumbnail_size=get_vals('  Thumbnail width & height (space seperated). ', ,
                       "Please enter a width and height. For example: 32 26 " , ,
                        thumbnail_size,2)
say
autogif=yesno('  Create a thumbnail for .GIF files (if necessary)')

write_gif_size=0; write_transparent=0
say
write_gif_size=yesno('  Try to write the dimensions (of image files) on the thumbnail')
if write_gif_size>0 then do
    write_gif_size=write_gif_size+yesno('     Dimensions under thumbnail (Y), overlay (N) ')
      write_transparent=yesno('     Use transparent background when writing dimensions:')
    say
     text_width=get_vals('     Text width (? for help)', ,
                      '     Enter pixel width of text used to write thumbnail information', ,
                      text_width,1)
     text_height=get_vals('     Text height (? for help)', ,
                     '     Enter pixel height of text used to write thumbnail information', ,
                      text_height,1)
    say
    text_color=get_String('     Text color of dimensions (rrggbb)',text_color)
   text_bcolor=get_string('   & text background color  (0-255, or rrggbb).',text_bcolor)
end
say
pad_with=get_string(bold ' Padding string:','     ')
say
inclusion=get_string('  Optional 'bold'inclusion list: 'normal,inclusion)
say
isverbose=yesno('  Verbose output? ')
call init_params        /* re initialize some paramters */


return 1


/***********************/
/* get_vals */
get_vals:procedure  expose reverse cy_ye bold normal 
parse arg amess,helpmess,defval,nvals

do forever
  atmp=strip(get_string(amess,defval))
  if atmp='?' then do
      say helpmess
      iterate
  end /* do */

  if words(atmp)<>nvals then do
     say helpmess
     iterate
  end
  iserr=0
  do jmm=1 to nvals
      if datatype(word(atmp,jmm))<>'NUM' then do
           say "Bad entry (not a number):" word(atemp,jmm) ' : please re-enter '
           iserr=1
           leave
      end /* do */
  end
  if iserr=0 then leave

end /* do */
return atmp




/*********/
get_string:procedure expose bold normal reverse
parse arg amess,defval

a2='  'reverse||'Enter='normal||defval||normal||bold||' : 'normal
if length(amess)+8+2*length(defval)<72 then do
   call charout,amess||a2
end
else do
   say amess
   call charout,'   'a2
end
parse pull tmp1

if tmp1='' then
  return defval
else
  return tmp1


/*****************************************/
/* look for a thumbnail */
check_for_tnail:
   yow=sysfiletree(cachedir'\*.ind',inds,'FO')
   if inds.0=0 then do
        say " Sorry, there are no thumbnail thumbnail indices available. "
        return 1
   end /* do */
   if inds.0=1 then do
       say "Using index file: "inds.1
       indfile=inds.1
   end /* do */
   else do
       indfile=''
       do until theind<>''
          indfile=which_ind()
       end /* do */
  end
  say '(the 'indfile' index will be checked). '
  say "Fully qualified fileame to look for,  or ENTER to show a list of files:"
  call charout, bold "?" normal
  parse pull checkfile
  if checkfile='?' | checkfile='' then do
     say "Displaying list of files with available thumbnails."
     call show_filelist(indfile)
     return 1
  end /* do */

  say " Looking for " checkfile
  afoo=linein(indfile) ; foo=stream(indfile,'c','close')
  parse  var afoo reclen numrec idlen .

  aa=search_fixed(checkfile,indfile,numrec,reclen+2,1,1,idlen,0)
  if aa="" then do
     say "No thumbnail for "checkfile
  end /* do */
  else do
      aa=translate(aa,' ','0d0a'x)
     parse var aa filename cachename cachedate .
     yerf=date_match(filename,cachedate)
     if yerf<>0 then 
          say "Thumbnail  no longer valid "
     else
         say filename '--> ' cachename
  end /* do */

  return 1




/*********************/
/* initialize parameters */
init_params:

parse var thumbnail_size x32 y32
if datatype(x32)<>'NUM' | datatype(y32)<>'NUM' then do
   x32='' ; y32=''
end /* do */
if x32='' then do
    doconvert=0
    x32=32 ; y32=32
end /* do */
else do
   doconvert=1
end /* do */

if wordpos('SUPERUSER',translate(privset))+wordpos('THUMBNAIL',translate(privset))>0 then 
   not_on_the_fly=0


text_color=space(translate(translate(text_color),' ','#'),0)
text_bcolor=space(translate(translate(text_bcolor),' ','#'),0)

if verify(text_color,'0123456789ABCDEF')<>0 | length(text_color)<>6 then do  /* bad value, use defaults */
   r_text=122 ; g_text=122 ; b_text=122
end /* do */
else do
   r_text=x2d(substr(text_color,1,2))
   G_text=x2d(substr(text_color,3,2))
   b_text=x2d(substr(text_color,5,2))
end /* do */


if length(text_bcolor)<3& datatype(text_bcolor)='NUM' then do
    r_back=text_bcolor
    if r_back<0 | r_back>255 then r_back=0
    g_back=-1
end /* do */
else do
  if verify(text_bcolor,'0123456789ABCDEF')<>0 | length(text_bcolor)<>6 then do  /* bad value, use defaults */
     r_back=0 ; g_back=0 ; b_back=0
   end /* do */
  else do
     r_back=x2d(substr(text_bcolor,1,2))
     G_back=x2d(substr(text_bcolor,3,2))
     b_back=x2d(substr(text_bcolor,5,2))
  end /* do */
end

if datatype(text_height)<>'NUM' then text_height=10
if text_height=0 then text_height=10
h10=text_height

if datatype(text_width)<>'NUM' then text_width=5.2
if text_width=0 then text_width=5.2
wtxt=text_width

return 1



/*********************************/
/* make a thumbnail gif
   This is either from extented attributes, in which case the thumbnail
   starts with THM. If it's created on the fly (from a gif file),
   the thumbnail starts with THU. TMPM* files are temporary gif files,
   formed by taking  one image from an animated gif
*/
make_dathumb:procedure expose r_text b_text g_text nconvert nautos gif_exts r_back g_back b_back ,
                                write_transparent autogif  ,
                                write_gif_size doconvert h10 wtxt x32 y32 cachedir iwasx how_scale
parse arg cachedir_use,dafile,adate,tfile,padding,isverbose
      signal on syntax name ayikes 
      signal on error name ayikes 
      signal on halt name ayikes 
      signal on failure name ayikes 

   if cachedir_use=0 | cachedir_use='' then cachedir_use=cachedir
   nth_image_frac=0   /* image to use in animated gif = #images * nth_image_frac */

   orx='' ; ory='' ; foo2=0
   yowb=sysgetea(dafile,'.ICON',goticon)
   if yowb<>0 then foo2=1

/* no .icon ea found */
   if foo2<>0 then do      /* perhaps create one? */
      if isverbose=1 then say "   ! no .ICON ea " dafile
      if autogif=0 then return ''

      dafile_use=dafile
      dims=gif_info(dafile,'S2')
      parse var dims orx ory kimgs
      if orx <= 0 then do
           if pos('.GIF',dafile)>0 & isverbose=1 then say "  ... bad GIF file " dims
           return ''
      end
      if kimgs>1 then do
         dafile_use=mk_filename(cachedir'\TMPM','.GIF')
         if datatype(nth_image_frac)<>'NUM' then nth_image_frac=0
         trk=min(max(1,trunc(kimgs*nth_image_frac)),kimgs)
         goo=gif_info(dafile,trk,dafile_use)  
         if isverbose=1 & goo=0 then do
            say "   ... RXGDUTIL can not read multiple image gif: " dafile
            return ''            /* couldn't do it */
         end
         if isverbose=1 then say "   ... Extracted image # " trk " from animated gif."

      end

/* use rxgdutil to create thumbnail */
      fooo=stream(dafile_use,'c','close')
      im1=rxgdimagecreatefromgif(dafile_use)
      if im1<=1 then do
         if isverbose=1 then say "   ... RXGDUTIL could not read .gif file "
         if dafile_use<>dafile then foo=sysfiledelete(dafile_use)
         return ''            /* couldn't do it */
      end
      if orx>2000 | ory>2000 then do
          if isverbose=1 then say "    ... gif too big "
          yow=rxgdimagedestroy(im1)
          if dafile_use<>dafile then foo=sysfiledelete(dafile_use)
          return ''
      end /* do */
      im2=rxgdimagecreate(x32,y32)        /* write thumbnail to this buffer*/  

      select                            /* scale image .... */
        when how_scale=0 then do         /* just fit */
             tx32=x32 ; ty32=y32
        end /* do */
        when how_scale=1  then do         /* fit to min of image size and thumbnail size */
          TX32=MIN(ORX,X32)
          TY32=MIN(ORY,Y32)
        end
        otherwise do                    /* proportionally scale */
           if x32>orx & y32>ory then do /* image is smaller then thumbnail */
              TX32=MIN(ORX,X32)
              TY32=MIN(ORY,Y32)
           end
           else do
              vvx=orx/x32 ;  vvy=ory/y32 
              vvxy=max(vvx,vvy)
              tx32=min(orx/vvxy,x32); ty32=min(ory/vvxy,y32)
           end
        end
      end
      tx32=max(2,trunc(tx32)) ; ty32=max(trunc(ty32),2)

      foo=rxgdimagecopyresized(im2,im1,0,0,0,0,Tx32,Ty32,orx,ory) /* save using presetsize */
      if tfile="" then tfile=mk_filename(cachedir_use'\THU','.GIF',iwasx)

      if tfile<>'' then parse var tfile tfile iwasx

      wow=rxgdimagegif(im2,tfile) 
      nautos=nautos+1
      yow=rxgdimagedestroy(im1); yow=rxgdimagedestroy(im2)
      if isverbose>0  then say "   ... Thumbnail Created from .GIF : " dafile
      if dafile_use<>dafile then foo=sysfiledelete(dafile_use)
    end

    else do             /* found a .ICON ea */
       if isverbose=1 then say  "   ... .ICON ea found "
       if tfile="" then tfile=mk_filename(cachedir_use'\THM','.GIF')
       if isverbose=1 then    say "   .. about to get .ICON ea "
       afoo=do_ea2gif(dafile,tfile,isverbose)

       if afoo<>1 then do
          if isverbose=1  then say "    ... Problem with EA2GIF "
          return ''
       end
/* convert sizes? */
       if doconvert=1 then do
             if isverbose=1 then say "  ... converting size"
/* use rxgdutil to create thumbnail */
          im1=rxgdimagecreatefromgif(tfile)
          if im1>1 then do
            im2=rxgdimagecreate(x32,y32)        /* write thumbnail to this buffer*/  
            orx1=rxgdimagesx(im1) ;ory1=rxgdimagesy(im1)
            foo=rxgdimagecopyresized(im2,im1,0,0,0,0,x32,y32,orx1,ory1)
            wow=rxgdimagegif(im2,tfile)    /* resave to tfile */
            nconvert=nconvert+1
            yow=rxgdimagedestroy(im1); yow=rxgdimagedestroy(im2)
          end
        end /* doconvert */

    end         /* .ICON ea processing */

/* record this file */
/* record the size, if possible */
  uui=get_image_dimensions(dafile)
  if uui<>' ' then do
      parse var uui orx ory ; orx=strip(orx); ory=strip(ory)

/* write size atop of the thumbnail image */
      if write_gif_size>0 then do
              if isverbose=1 then say "  ... writing dimensions"
              im1=rxgdimagecreatefromgif(tfile)
              torx=rxgdimagesx(im1); tory=rxgdimagesy(im1)   
              amess=orx'x'ory
              ww=trunc(length(amess)*5.2)
              im2=rxgdimagecreate(ww,10)
              if g_back<0 then do
                rbck=rxgdimagered(im1,r_back) 
                gbck=rxgdimagegreen(im1,r_back) 
                bbck=rxgdimageblue(im1,r_back) 
              end
              else do
                  rbck=r_back; gbck=g_back; bbck=b_back
              end /* do */
              icc0=rxgdimagecolorallocate(im2,rbck,gbck,bbck)
              if write_transparent=1 then uu=rxgdimagecolortransparent(im2,icc0)
              yy=rxgdimagefilledrectangle(im2,0,0,torx-1,tory-1,0)
              icc=rxgdimagecolorallocate(im2,r_text,g_text,b_text)

/* now write size to thumbnail */           
              foo1=rxgdimagestring(im2,'T',0,0,amess,icc)
              wis=min(torx,ww*wtxt/5.2)
      end
      if write_gif_size=1 then do  /*write on top */
              foo2=rxgdimagecopyresized(im1,im2,0,tory-(h10+1),0,0,wis,h10,ww,10)
              foo3=rxgdimagegif(im1,tfile)    /* resave to tfile */
              yow=rxgdimagedestroy(im1)
              yow=rxgdimagedestroy(im2)
      end
      if write_gif_size=2 then do   /* write underneath (i.e.; shrink thumbnail*/
              im3=rxgdimagecreate(torx,tory)
              foo2=rxgdimagecopyresized(im3,im1,0,0,0,0,torx,tory-h10,torx,tory)
              foo2=rxgdimagecopyresized(im3,im2,0,tory-h10,0,0,wis,h10,ww,10) 
              foo3=rxgdimagegif(im3,tfile)    /* resave to tfile */
              yow=rxgdimagedestroy(im1)
              yow=rxgdimagedestroy(im2)
              yow=rxgdimagedestroy(im3)
      end
    end /* found a size (PNG BMP PCX GIF JPG  */

    if orx<>' ' then 
      ooze=orx'x'ory
    else
      ooze=''
    if length(pad_with)>length(ooze) then ooze=overlay(ooze,padding)
    return dafile' 'tfile' 'adate' 'ooze


ayikes:
foo=rxfuncquery('pmprintf')
if foo=0 then 
   call pmprintf(' Thumbnail error at line: ' sigl', 'rc)
else
  say "BAD ERROR " sigl
exit


/**********************/
/* do ea2gif, watch for errors */
do_ea2gif:procedure
parse arg dafile,tfile,isverbose
signal on syntax name boogz
signal on error name boogz

if isverbose=1 then do
         address cmd '   EA2GIF 'dafile  ' ' tfile  '  Q '
end
else do
         address cmd '@EA2GIF 'dafile  ' ' tfile ' Q >> nul ' 
end

if isverbose=1 then    say "   .. got .ICON ea "

signal on syntax name ayikes
signal on error name ayikes

return 1

boogz:          /* here if problem, usually in ea2gif */
signal on syntax name ayikes
signal on error name ayikes
return 0




/******/
/* return 1 if .GIF file */
is_a_gif:procedure expose isverbose
parse upper arg afile,gexts
      fii=lastpos('.' ,afile);daext=strip(substr(afile,fii+1))
      if wordpos(daext,gexts)=0 then return 0
/* check that the size is not insane (which might signal unreadable by rxgdutil */

      asize=get_image_dimensions(afile)
      if isverbose=1 then say '   .. 'afile "    Size of .GIF=" asize
      if asize='' then return 0
      parse var asize aw ah
      if aw>1400 | ah > 1400 then return 0      /* too big */
      return  1


/***************/
show_filelist:procedure
parse arg afile

foo=linein(afile)
parse  var foo reclen nrecs idlen .
do mm=1 to nrecs
    if mm//20=0 then do
       if rxfuncquery('inkey')=0 then do
         call charout,' (press any key to continue, ESC to stop display) ' 
         foo=inkey(); call charout,'0d'x
         if c2d(foo)=27 then do ; say ; leave ; end
       end
       else do
         call charout,' (press ENTER to continue, X to stop display )'
         pull foo; call charout,'0d'x
         if foo='X' then leave
       end /* do */
    end /* do */
    foo=linein(afile)

    parse var foo afile0 cachefile datestamp info
    if stream(cachefile,'c','query exists')="" then do
         say "Missing thumbnail image-file: "cachefile
    end /* do */
    else do
      astat=date_match(afile0,datestamp)
      select
         when astat=1 then say "No such file:"afile0
         when astat=2 then say "Thumbnail is out of date for:"afile
         otherwise say afile0 '==>' cachefile
      end
    end
end
return 1


/***********/
/* check filestamp of dafile against dastamp 
return
0=ok
1=no such dafile
2=mismatch in timestamp */
date_match:procedure
parse arg dafile,dastamp
dastamp=strip(dastamp)
  aa=sysfiletree(dafile,yowk,'TF')
  if yowk.0=0 then return '1'
  parse var yowk.1 datestamp .  ; datestamp=strip(datestamp)
  if dastamp<>datestamp then return '2'
  return 0


/***************/
which_ind:procedure expose inds. bold cy_ye normal reverse

 say cy_ye "------------------------------------------- "normal
 aline=''
 do mm=1 to inds.0

     arf=filespec('n',inds.mm)     
     parse var  arf aa '.' .
     if mm//2=1 then
        aline=aline||bold' 'left(aa,10)' 'normal
     else
        aline=aline||normal' 'left(aa,10)' 'normal

     if length(aline)>70 then do 
        say aline
        aline=''
     end /* do */
 end /* do */
 if aline<>'' then say aline
aginx:
 call charout, bold "Select one of the above indices: "normal
 parse pull theind
 aa=filespec('d',inds.1)||filespec('p',inds.1)||theind'.ind'
 if stream(aa,'c','query exists')="" | theind='' then do
    say "No such index: " theind
    signal aginx
 end
 return aa


/**************************/
/* create unused file name, numbered from 1....*/
mk_filename:procedure
parse arg aname,aext,mm0

domm0=0
if mm0<>'' then domm0=1

if mm0='' | datatype(MM0)<>'NUM' then mm0=0
f1=aname||'9999'||aext

do mm=mm0+1 to 9999
    f1=aname||mm||aext
    if stream(f1,'c','query exists')="" then do
      if domm0=0 then  
            return f1       /* use name9999.ext in a pinch */
      else 
          return f1' 'mm
    end
end /* do */

if domm0=0 then 
  return f1       /* use name9999.ext in a pinch */
else 
  return f1' 'mm


/* See if directory exists , 0=no 1=yes*/
dir_exists:procedure

parse upper arg lookfor
lookfor=strip(lookfor,'t','\')

adrive=filespec('d',lookfor)       /* does drive exist? */
if adrive<>"" then do
  oo2=sysdrivemap(,'used')
  if pos(translate(adrive),translate(oo2))=0 then return 0   /* no such drive */
end
eek=lastpos('\',lookfor)
if eek>0 then do
  lookfor1=substr(lookfor,eek+1)
  foo=delstr(lookfor,eek)
end
else do
   return 1       /* it's a root dir */
end /* do */
foo=foo'\*.*'
aa=sysfiletree(foo,'eek','DO')
do mm=1 to eek.0
   if translate(filespec('n',eek.mm))=lookfor1 then do 
       return 1
   end /* do */
end /* do */
return 0

/***************/
/*Search a sorted, fixed record file for a match 
--- OR, if WILDCARD match -- do a one at a time match (slow but thourough)

target: string to look for (case insensitive)
thefile: sorted "fixed length record" file to look in
numrec:number of records (NOT including offset)
reclen:length of fixed-length records
recoffset: Number of records to skip (start search at recoffset+1'th record0
idat: Identifier starts at byte idat
idlen: Length (# bytes) of identifier
exact: if 1, exact match only (i.e.; case sensitive and no stripping of spaces)
       if 2 nth,  then nth wildcard match of nth; i.e.; 2 4
                   2 by itself means "first wildcard match "

Returns record which matches, or blank if no match 
*/

search_fixed:procedure

parse arg target,thefile,numrec,reclen,recoffset,idat,idlen,exact
exact=strip(exact)
oo=stream(thefile,'c','open read')
if abbrev(translate(oo),'READY')<>1 then return ''    /* could not open, could not read */

  ib=1
  ie=numrec
  iat=((recoffset+ib-1)*reclen)+idat
  indxib=charin(thefile,iat,idlen)

/* search for nthm match, using wildcards? */
  if left(exact,1)=2 then do            /* one-ata-time */
      parse var exact ll nthm
      if nthm=''  then nthm=1
      if datatype(nthm)<>'NUM' then nthm=1
      if nthm<0 then nthm=1
      ism=0
      do mm=1 to numrec
         iat=((recoffset+mm-1)*reclen)+idat
         needle=charin(thefile,iat,idlen)
         dam=wild_match(needle,target)
         if dam<>"0" then do
            ism=ism+1
            if ism<>nthm then iterate
            iee=((recoffset+mm-1)*reclen)+1
            fgoo=charin(thefile,iee,reclen)
            foo=stream(thefile,'c','close')
            return fgoo
         end            /* wild match */
     end                /* mm=1..numrec */
     foo=stream(thefile,'c','close')
     return ''           /* no match */
  end              /* wildcard match */

  if exact<>1 then indxib=strip(translate(indxib))

  iat=((recoffset+ie-1)*reclen)+idat
  indxie=charin(thefile,iat,idlen)
  if exact<>1 then indxie=strip(translate(indxie))
  
  if exact<>1 then target=strip(translate(target))
  
  if target << indxib then do
      foo=stream(thefile,'c','close')
      return ''
   end
  if target>>indxie then do
      foo=stream(thefile,'c','close')
      return ''
  end

/* do the binary search */
  do forever
   len=ie-ib+1
   if (len<=2) then do
     if indxie==target then  do
         iee=((recoffset+ie-1)*reclen)+1
         fgoo=charin(thefile,iee,reclen)
         foo=stream(thefile,'c','close')
         return fgoo
     end
     if indxib==target then do
         iee=((recoffset+ib-1)*reclen)+1
         fgoo=charin(thefile,iee,reclen)
         foo=stream(thefile,'c','close')
         return fgoo
     end
     foo=stream(thefile,'c','close')
     return ''  /* did not match */
   end

   imid=trunc(ib+(len/2))
   iat=((recoffset+imid-1)*reclen)+idat
   indximid=charin(thefile,iat,idlen)
   if exact<>1 then indximid=strip(translate(indximid))
   if indximid==target then do
         iee=((recoffset+imid-1)*reclen)+1
         fgoo=charin(thefile,iee,reclen)
         foo=stream(thefile,'c','close')
         return fgoo
   end

   if (indximid<<target) then do
       indxib=indximid
       ib=imid
   end
   else do
       ie=imid
       indxie=indximid
   end
end

/***************/

/************************/
/* Do a multi wild card match -- return stats on match
   Stats are list of letter positions (in needle) that are matched
   Or, -1 for "exact match"
   OR, 0 for "no match"
Example: Needle="THIS/IS/VERY/SILLY"
        haystack="THIS*VERY*"
        would yield: 1 2 3 4 9 10 11 12
 One can then compare this result list to other result lists (to ascertain
 best match */


wild_match:procedure
parse upper arg needle, haystack ; haystack=strip(haystack)
needle=strip(needle)

if needle=haystack then return -1        /* -1 signals exact match */
ast1=pos('*',haystack)
if ast1=0 then return 0                 /* 0 means no match */
if haystack='*' then  do
   if length(needle)=0 then 
       return 100000
    else 
        return length(needle)
end
ff=haystack
ii=0
do until ff=""
  ii=ii+1
  parse var ff hw.ii '*'  ff
  hw.ii=strip(hw.ii)
end
if hw.ii='' then ii=ii-1
hw.0=ii


/* check each component of haystackw against needle -- all components
must be there */

resu=' '
istart=1 ; ido=2
if ast1>1 then do       /* first check abbrev */
  if abbrev(needle,hw.1)=0 then return 0
  aresu=length(hw.1)
  if hw.0=1 then do
     do nm=1 to aresu
        resu=resu||' '||nm
     end /* do */
     return resu         /* if haystacy of form abc*, we have a match */
  end
  ido=2 ; istart=aresu+1
  do mm=1 to aresu
        resu=resu||' '||mm
  end /* do */
end
/* if here, then first part (a non wildcard) of haystack matches first
part of needle
Now check sequentially that each remaining part also exists
*/
do mm=ido to hw.0
  igoo=pos(hw.mm,needle,istart)
  if igoo=0 then return 0
  tres=length(hw.mm)
  istart=igoo+tres
  do nn=igoo to (istart-1)
     resu=resu||' '||nn
  end /* do */
end
if istart >= length(needle) | right(haystack,1)='*' then
   return resu
return 0
 




/***************/

 /* ------------------------------------------------------------------ */
 /* function: Check if ANSI is activated                               */
 /*                                                                    */
 /* call:     CheckAnsi                                                */
 /*                                                                    */
 /* where:    -                                                        */
 /*                                                                    */
 /* returns:  1 - ANSI support detected                                */
 /*           0 - no ANSI support available                            */
 /*          -1 - error detecting ansi                                 */
 /*                                                                    */
 /* note:     Tested with the German and the US version of OS/2 3.0    */
 /*                                                                    */
 /*                                                                    */
 CheckAnsi: PROCEDURE
   thisRC = -1

   trace off
                         /* install a local error handler              */
   SIGNAL ON ERROR Name InitAnsiEnd

   "@ANSI 2>NUL | rxqueue 2>NUL"

   thisRC = 0

   do while queued() <> 0
     queueLine = lineIN( "QUEUE:" )
     if pos( " on.", queueLine ) <> 0 | ,                       /* USA */
        pos( " (ON).", queueLine ) <> 0 then                    /* GER */
       thisRC = 1
   end /* do while queued() <> 0 */

 InitAnsiEnd:
 signal off error
 RETURN thisRC





/* -------------------- */
/* get a yes or no , return 1 if yes */
yesno:procedure expose normal reverse bold
parse arg fooa , allopt,altans
if altans<>" " & words(altans)>1 then do
   w1=strip(word(altans,1))
   w2=strip(word(altans,2))
   a1=left(w1,1) ; a2=left(w2,1)
   a1a=substr(w1,2) ; a2a=substr(w2,2)
end
else do
    a1='Y' ; a1a='es'
    a2='N' ; a2a='o'
end  /* Do */
ayn='  'bold||a1||normal||a1a||'\'||bold||a2||normal||a2a
if allopt=1 then  ayn=ayn||'\'||bold||'A'||normal||'ll'

do forever
 foo1=fooa||normal||ayn
 call charout,  foo1 normal ':'
 pull anans
 if abbrev(anans,a1)=1 then return 1
 if abbrev(anans,a2)=1 then return 0
 if allopt=1 & abbrev(anans,'A')=1 then return 2
end

nocon:
if rc=-7 then return 0
exit 0

gpmprintf:procedure expose is_cgi
parse arg a1

if is_cgi=2 then do
  say a1
  return 1
end

if rxfuncquery('pmprintf')=0 then
    call pmprintf(a1)
return 0



/**********************/
isyes:procedure
parse upper arg aa
if  wordpos(aa,'YES Y 1')>0 then return 1
return 0

/**********************/
/* load dlls */
load_dlls:
foo=rxfuncquery('rxgdloadfuncs')
if foo=1 then do
  Call RxFuncAdd 'RxgdLoadFuncs', 'RXGDUTIL', 'RxgdLoadFuncs'
  Call RxgdLoadFuncs
end
foo=rxfuncquery('rxgdloadfuncs')
if foo=1 then do
    say " Could not find RXGDUTIL "
    exit
end /* do */

/* Load up advanced REXX functions */
foo=rxfuncquery('sysloadfuncs')
if foo=1 then do
  call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
  call SysLoadFuncs
end


foo=rxfuncquery('rexxlibregister')
if foo=1 then do
 call rxfuncadd 'rexxlibregister','rexxlib', 'rexxlibregister'
 call rexxlibregister
end
foo=rxfuncquery('rexxlibregister')
if foo=1 then do
    say " Could not find REXXLIB "
    exit
end /* do */
return 1



/******/
/* check thumbnail dir */

getnail:

getnail2:cachedir=translate(strip(thumbnail_dir,'t','\'))
if dir_exists(cachedir)<>1 then do
    Say "ERROR: default caching directory unavailable: "thumbnail_dir
    call charout, "Please enter a new caching directory: "
    pull thumbnail_dir
    signal getnail2
end /* do */

return 1



/*********************/
/* sort suclist array. Use arraysort if available, otherwise indx_sort */
arraysort2:procedure expose suclist. 
parse arg tfile,tfile1,tfile2

if rxfuncquery('arraysort')=0 then do
   foo=arraysort(suclist)
   return foo
end /* do */

/* no arraysort -- use the SORT program */
do mm=1 to suclist.0
   call lineout tfile1,suclist.mm
end /* do */
call lineout tfile1
address cmd '@SORT < 'tfile1 '> ' tfile2
if rc<>0 then do
   say " Error in SORT routine (probably the index is too big) "
   say " Try making few thumbnails; or, get REXXLIB (it has a better sorter)"
   exit
end /* do */
do mm=1 to suclist.0
   suclist.mm=linein(tfile2)
end /* do */
foo=sysfiledelete(tfile1)
foo=sysfiledelete(tfile2)
return 1


/***************************/
/* read image dimensions; for gif, bmp, jpeg, png, and pcx files */
get_image_dimensions:procedure
parse upper arg filename

foo=lastpos('.',filename)
if foo=0 then return ' '
anext=substr(filename,foo+1)
signal on error name nosuch ; signal on syntax name nosuch
select
   when abbrev(anext,'GIF')=1 then eek=gif_info(filename,'S') 
   when anext='JPG' | anext='JPEG' then eek=litjpg(filename)
   when anext='BMP'  then eek=litbmp(filename)
   when anext='PNG' then eek=litpng(filename)
   when anext='PCX' then eek=litpcx(filename)
   otherwise eek=''
end  /* select */
signal off error ; signal off syntax 
return eek

nosuch:
signal off error ; signal off syntax 
return ''

/*********************************************************************
Adapted from the GRFXREXX package
 (available at http://hobbes.nmsu.edu ); they were written by Raphal Vanney, 09/95

 The purpose of this REXX program is to get information from a BMP file.
 There's of course no waranty of any kind associated to it. Use freely.
**********************************************************************/

litbmp:procedure
Parse Arg FName
Drop BMP.

If FName="" Then Return " "

/* read file header */

aa=CharIn(FName, 1, 2)
Hdr=C2D(Reverse(aa))             /* type */
BMP.fsize=C2D(Reverse(CharIn(FName, , 4)))        /* which size ? */
BMP.rsv=C2D(Reverse(CharIn(FName, , 4)))          /* should be 0 */

If (Hdr<>19778) | (BMP.rsv<>0) Then return ' '

BMP.offbits=C2D(Reverse(CharIn(FName, , 4)))
BMP.isize=C2D(Reverse(CharIn(FName, , 4)))
BMP.width=C2D(Reverse(CharIn(FName, , 4)))        /* bitmap width */
BMP.height=C2D(Reverse(CharIn(FName, , 4)))       /* bitmap height */

Return BMP.width||"  "||BMP.height



/*********************************************************************
 LitJPEG - Raphal Vanney, 09/95

 The purpose of this REXX program is to get information from a JPEG
 file. There's of course no waranty of any kind associated to it. Use
 freely.
**********************************************************************/

litjpg:procedure
Parse Arg FName
Drop JPEG.

If FName="" Then Return " "

/* read file header */

Hdr=C2X(CharIn(FName, 1, 2))

If Hdr<>"FFD8" Then Return " "

NxtSeg=3
Do While (Seg.Type<>"D9") & (NxtSeg<>-1) & (JPEG.height="JPEG.HEIGHT")
     NxtSeg=LitSegment(NxtSeg)
End

Drop Hdr NxtSeg Seg. Res FName

If JPEG.height<>"JPEG.HEIGHT" then 
  Return JPEG.width||"  "||JPEG.height
Else
  Return " "

LitSegment:         /* reads a JPEG segment's header from the input file */
Arg SegPos

Seg.marker=C2X(CharIn(FName, SegPos))
If Seg.marker<>"FF" Then
Do
     Return -1
End
Seg.Type=C2X(CharIn(FName))
Res=SegPos+2                  /* position of next segment */
If (Seg.Type="01") | ((Seg.Type>="D0") & (Seg.Type<="D9")) Then
Do   /* these segments contain no data nor length info */
     Seg.Len=0
End
Else
Do
     Seg.Len=C2D(CharIn(FName, , 2))
End
Res=Res+Seg.Len

If (Seg.Type="C0") | (Seg.Type="C2") Then
Do
     /* start of frame 0 */
     JPEG.bps=C2D(CharIn(FName))             /* bits per sample */
     JPEG.height=C2D(CharIn(FName, , 2))
     JPEG.width=C2D(CharIn(FName, , 2))
End

Return Res

/*********************************************************************
 LitPCX - Raphal Vanney, 09/95

 The purpose of this REXX program is to get information from a PCX file.
 There's of course no waranty of any kind associated to it. Use freely.
**********************************************************************/
litpcx:procedure
Parse Arg FName
Drop PCX.

If FName="" Then Return " "

/* read file header */

Hdr=C2D(CharIn(FName, 1))                    /* manufacturer */
PCX.version=C2D(CharIn(FName))               /* PaintBrush version */
PCX.comp=C2D(CharIn(FName))                  /* encoding (1=RLL) */
PCX.bits=C2D(CharIn(FName))                  /* bits per pixel */
PCX.xmin=C2D(Reverse(CharIn(FName, , 2)))
PCX.ymin=C2D(Reverse(CharIn(FName, , 2)))
PCX.xmax=C2D(Reverse(CharIn(FName, , 2)))
PCX.ymax=C2D(Reverse(CharIn(FName, , 2)))
PCX.width=PCX.xmax-PCX.xmin+1
PCX.height=PCX.ymax-PCX.ymin+1

Return PCX.width||"   "||PCX.height

/*********************************************************************
 LitPNG - Raphal Vanney, 09/95

 The purpose of this REXX program is to get information from a PNG file.
 There's of course no waranty of any kind associated to it. Use freely.
**********************************************************************/
litPng:procedure
Parse Arg FName
Drop PNG.

If FName="" Then Return " "

/* read file header */

Hdr=CharIn(FName, 1, 8)
If Hdr<>(D2C(137)||"PNG"||D2C(13)||D2C(10)||D2C(26)||D2C(10)) Then
     Return " "

NxtSeg=9
Do While (Seg.Type<>"IEND") & (NxtSeg<>-1) & (PNG.height="PNG.HEIGHT")
     NxtSeg=LitSegment(NxtSeg)
End

Drop Hdr NxtSeg Seg. Res FName
          
If PNG.height<>"PNG.HEIGHT" Then 
  Return PNG.width||"  "||PNG.height
Else
  Return " "

LitSegment:         /* reads a PNG chunk's header from the input file */
Arg SegPos

Seg.len=C2D(CharIn(FName, SegPos, 4))   /* length of chunk's DATA */
Seg.type=CharIn(FName, , 4)             /* chunk type */
Res=SegPos+12+Seg.len                   /* position of next chunk */

If Seg.type="IHDR" Then
Do
     /* header chunk */
     PNG.width=C2D(CharIn(FName, , 4))
     PNG.height=C2D(CharIn(FName, , 4))

Return Res


/************************************************/
/* procedure from TEST-CGI.CMD by  Frankie Fan <kfan@netcom.com>  7/11/94 */
DecodeKeyVal: procedure
  parse arg Code
  Text=''
  Code=translate(Code, ' ', '+')
  rest='%'
  do while (rest\='')
     Parse var Code T '%' rest
     Text=Text || T
     if (rest\='' ) then
      do
        ch = left( rest,2)
        if verify(ch,'01234567890ABCDEF')=0 then
           c=X2C(ch)
        else
           c=ch
        Text=Text || c
        Code=substr( rest, 3)
      end
  end
  return Text



/*****************/
/* make big pictures out of thumbnails*/
make_bigpicture:
parse arg cdir2

text_color=space(translate(translate(opts.!text_color),' ','#'),0)
text_bcolor=space(translate(translate(opts.!text_bcolor),' ','#'),0)

if verify(text_color,'0123456789ABCDEF')<>0 | length(text_color)<>6 then do  /* bad value, use defaults */
   r_text=122 ; g_text=122 ; b_text=122
end /* do */
else do
   r_text=x2d(substr(text_color,1,2))
   G_text=x2d(substr(text_color,3,2))
   b_text=x2d(substr(text_color,5,2))
end /* do */

if length(text_bcolor)<3& datatype(text_bcolor)='NUM' then do
    r_back=text_bcolor
    if r_back<0 | r_back>255 then r_back=0
    g_back=-1
end /* do */
else do
  if verify(text_bcolor,'0123456789ABCDEF')<>0 | length(text_bcolor)<>6 then do  /* bad value, use defaults */
     r_back=0 ; g_back=0 ; b_back=0
   end /* do */
  else do
     r_back=x2d(substr(text_bcolor,1,2))
     G_back=x2d(substr(text_bcolor,3,2))
     b_back=x2d(substr(text_bcolor,5,2))
  end /* do */
end


ifnd=0

/* find & store all valid entries in the thumbnail index */
 call get_good_entries         /* find and store, in gotlist, good entries */


/* now, create the big picture(s) */
/* max width is 555 pixels. Use 12 x 12 if possible. If not (due
   to 12 * (x32+5) >  555, use small # of pictures per row.
*/
  newwid=x32+3
  if datatype(opts.!big_col)='NUM' & opts.!big_col<>0 & opts.!big_col<>'' then do /* explicit takes priority */
       docols=opts.!big_col
  end
  else do                       /* try 10 columns */
      if newwid>trunc(555/10) then 
        docols=trunc(555/newwid)
      else
        docols=10
  end

immes=rxgdimagecreate(120,11)  /* filename buffer */
jcc0=rxgdimagecolorallocate(immes,r_back,g_back,b_back)

if write_transparent=1 then uu=rxgdimagecolortransparent(immes,jcc0)
ff=rxgdimagefilledrectangle(immes,0,0,119,10,jcc0)
jcc1=rxgdimagecolorallocate(immes,r_text,g_text,b_text)

/* now figure max rows -- pixels of 550 */
newht=y32+12
if datatype(opts.!big_row)='NUM' & opts.!big_row<>0 & opts.!big_row<>'' then do /* explicit takes priority */
       dorows=opts.!big_row
end
else do
   if newht>42 then
      dorows=trunc(420/newht)
   else
     dorows=10
end

/* place docols x dorows  images into imbuf */
  idid=0 ; ng1=1 ; maxaname=1
  do kk=1 to gotlist.0
      if idid=0 then do
           call make_empty_image    /* for filling with thumbnails */
      end /* do */
      idid=idid+1
      im1=rxgdimagecreatefromgif(gotlist.kk.2)
      isx=rxgdimagesx(im1); isy=rxgdimagesy(im1)
      aname=filespec('n',gotlist.kk.1)
      maxaname=max(length(aname),maxaname)

      irow=trunc((idid-0.01)/docols) ; icol=idid-(irow*docols) 
      yat=irow*(y32+12)  ; xat=(icol-1)*newwid
      yow=rxgdimagecopyresized(imbuf,im1,xat,yat,0,0,x32,y32,isx,isy)
      gotlist.kk.!l=xat ; gotlist.kk.!u=yat
      gotlist.kk.!r=xat+x32 ; gotlist.kk.!b=yat+newht-1

     foo=rxgdimagedestroy(im1)  

     select
        when opts.!big_mess='NONE' then  damess=''
        when opts.!big_mess='DATE' then damess=gotlist.kk.!date
        when opts.!big_mess='THUMB' then damess=gotlist.kk.!mess
        otherwise damess=aname
     end  /* select */
     if damess<>'' then do
       ff=rxgdimagefilledrectangle(immes,0,0,119,11,jcc0)  /* clear it */
       foo=rxgdimagestring(immes,'T',1,1,damess,jcc1)  /* name into temp buffer */
       messwid=trunc(maxaname*5.7) ; mw1=messwid; mw2=messwid
       if messwid>x32 then do
           mw1=x32 ; mw2=x32
       end /* do */
       yow=rxgdimagecopyresized(imbuf,immes,xat,yat+y32,0,0,mw1,11,mw2,11)
     end
    if kk=gotlist.0 | idid=docols*dorows then do /* done, or filled up */
         bigit=mk_filename(cachedir||'\'||cdir2||'\BIG','.GIF')
         foo=rxgdimagegif(imbuf,bigit)
         foo=rxgdimagedestroy(imbuf)  
         call outit ' '
         call outit ' <!-- Thumbnails ' ng1 ' to ' kk ' (stored in  ' bigit ' -->'

         aa=strip(thumbnail_dir_sel,,'/')   /* display the bigit image */
         aa='/'aa'/'||translate(substr(bigit,length(cachedir)+2),'/','\')
         if opts.!big_clientmap<>1 then do
           call outit '<img src="'aa'"> <p>'
         end
         else do
           mapname=filespec('N',bigit) ; a1=lastpos('.',mapname)
           mapname=delstr(mapname,a1)
           call outit '<img src="'aa'" usemap="#'mapname'"> <p>'
           call make_clientmap 
         end
         idid=0 ; ng1=kk+1 ; maxaname=1
    end         

   end          /* the gotlist */

 foo=rxgdimagedestroy(immes)
  
return 1


/* make a clientmap, using info in gotlist */
make_clientmap:
call outit ' '
call outit '<map name="'mapname'">'
if opts.!VUIN=1 | abbrev(translate(strip(opts.!VUIN)),'Y')=1 then
   vuin=' TARGET="VIEWIN" '
else
   vuin=' '
do tm=ng1 to kk
   clist=gotlist.tm.!l','gotlist.tm.!u','gotlist.tm.!r','gotlist.tm.!b
   isalt=gotlist.tm.!imess
   call outit '<area shape="rect" coords="'clist'" href="'gotlist.tm.3||'"'||vuin||' ALT="'||isalt||'" >'
end /* do */
call outit '<area shape="default" nohref>    '
call outit '</map> '

return 1


/* make an image buffer */
make_empty_image:

/* if gotlist.0-kk > dorows*docols, then make full height box
   else, make non-full height */
  isfoo=1+gotlist.0-kk 
  if isfoo>=(docols*dorows) then do
      foorows=dorows
  end /* do */
  else do
      foorows=trunc(0.999+(isfoo/docols))
  end /* do */

  wbufsize=newwid*docols
  hbufsize=newht*foorows
  imbuf=rxgdimagecreate(wbufsize,hbufsize)
  icc0=rxgdimagecolorallocate(imbuf,r_back,g_back,b_back)
  if write_transparent=1 then uu=rxgdimagecolortransparent(imbuf,icc0)
  ff=rxgdimagefilledrectangle(imbuf,0,0,wbufsize-1,hbufsize-1,icc0)
  icc1=rxgdimagecolorallocate(imbuf,r_text,g_text,b_text)
  return 1
end


/***************/
/*find and store, in gotlist, good entries of those listed in theind index*/
get_good_entries:
  cachedir=strip(translate(strip(thumbnail_dir,'t','\')))
  do mm=1 to numrec
     aa=linein(theind)
     parse var aa afilename acachename datestamp  amess imess  

     if is_cgi=0 & pos(':',afilename)=0 then
       filename=sref_do_virtual(ddir,afilename,enmadd,0,transaction,homedir,host_nickname)
    else
       filename=afilename

     cachename=cachedir||'\'||strip(translate(acachename,'\','/'),,'\')

     filename=strip(filename)
     cachename=strip(cachename)

     if stream(filename,'c','query exists')='' then iterate
     if stream(cachename,'c','query exists')='' then iterate

/* don't bother for now
     im2=rxgdimagecreatefromgif(cachename)
     if im2<=1 then iterate
     yow=rxgdimagedestroy(im2) */

     ifnd=ifnd+1
     gotlist.ifnd.1=filename ; gotlist.ifnd.2=cachename

     selname=strip(translate(substr(filename,cshlen+1),'/','\'),,'/')
     dasel=strip(dasel,,'/')
     gotlist.ifnd.3='/'dasel'/'selname
     if imess=''  then do
        parse value filespec('n',filename) with imess '.' .
     end      
     gotlist.ifnd.!imess=imess
     
     gotlist.ifnd.!date=datestamp
     gotlist.ifnd.!mess=amess

  end
  gotlist.0=ifnd

  return 1


/**********************/
/* make a directory listing of all directories under /
  (display as relative to / */
make_dirlist:
call outit 
call outit "<nobr><b>Directories</b><br>"
call outit '<form name="TT">'
call outit '<table bgcolor="#aabbaa"><tr ><td><font size=-1>Chosen Dir:</font></td>'
call outit '<td><input type="TEXT" value="/" size=30 name="CHOSEN"></td>'
call outit '<tr> '
call outit ' <td colspan=2><Input type="checkbox" value=1 name="WHAT_DIRAT"'
call outit ' onClick="next_dir() ; window.document.TT.WHAT_DIRAT.checked=false; return true"'
call outit '   Get the <b>next</b> directory.'
call outit '</table></form>'
call lineout tempfile,'<ul compact type="CIRCLE">'
call lineout tempfile,'<li> <a href="/" '
call lineout tempfile,'onClick="do_chosen('||"'/'"||',0);return false">'
call lineout tempfile,'/ (root) </a> '
ddlist.=0
ddlist.0='/'

nddir=length(ddir)
extlist='JJGMTTP'
extlist2='JPG JPEG GIF BMP TIF TIFF PNG'
tseldir='/'||translate(strip(thumbnail_dir_sel,,'/'))||'/'
do mm=1 to dirs.0
  cdir=dirs.mm
  founds=''
  thissel=substr(translate(cdir,'/','\'),nddir)
  if abbrev(translate(thissel)"/",tseldir)=1 then  iterate /* skip thumbnail cache dir */

  npics=0
  do ac=1 to length(extlist)
     ac2=substr(extlist,ac,1)  
     atype2=word(extlist2,ac)
     oo=sysfiletree(cdir'\*.'||atype2,'ff.','FO')
     if ff.0=0 then iterate
     if pos(ac2,founds)=0 then founds=founds||ac2
     npics=npics+ff.0
  end
  if founds<>'' then founds='  <font size=-1><em>('||founds||' = '||npics||')</em></font>'
  call lineout tempfile,'<li> <a href="'||thissel||'" '

  call lineout tempfile,'onClick="do_chosen(this.pathname,'mm');return false">'
  call outit thissel||'</a>'||founds

  ddlist.mm=thissel
  ddlist.!all=mm


end /* do */
call outit ' </ul><p><font size=-1><em>(BJGTP)</em> signify BMP, JPG, GIF, TIFF,<br> or PNG files detected in a directory.</font>'
call outit '</nobr>'

call outit ' '
call outit '<script language="javascript">'
call outit '<!-- '
call outit 'dirarray=new Array('||ddlist.!all||') ;'
do jjj=0 to ddlist.!all
  call outit ' dirarray['||jjj||']="'||ddlist.jjj||'";'
end
call outit ' // end of hiding -->'
call outit' </script>'


return 0


/**********************/
/* GIF_INFO is called as:
     stuff=GIF_INFO(gif_file,infotype)

*/

gif_info:procedure 
parse  arg afile,atype,afilenew
atype=translate(atype)

atype=strip(atype)
dodisp=0
delay=-1

if datatype(atype)='NUM' then do
   getnth=atype ; atype='E'
end /* do */


fqn=stream(afile,'c','query exists')
  if fqn='' then do
    return ''
  end
  fooo=stream(afile,'c','close')
  gifver=charin(fqn,1,6)
  if abbrev(translate(gifver),'GIF8')=0 then  do
     oo=stream(afile,'c','close')
     return   -1
  end
  oo=stream(afile,'c','close')
  filesize=chars(fqn)
  ain=charin(fqn,1,filesize)
  oo=stream(afile,'c','close')

gifver=left(ain,6)
if abbrev(translate(gifver),'GIF8')=0 then   return   -1

l1=substr(ain,7,2)
g_width=c2d(reverse(l1))
l2=substr(ain,9,2)
g_height=c2d(reverse(l2))

l3=substr(ain,11,1)
ctable0=x2b(c2x(l3))

global_color_flag=left(ctable0,1)

ct1=right(ctable0,3)
ct1=right(ct1,8,0)
ct1=x2d(b2x(ct1))
numcolors=2**(ct1+1)

iat=13          /* 11 bytes used for intro info */

iat=iat+(3*numcolors)  /* iat is the Last byte used */

section_gc=''
section_image=''
termx='3b'x

if atype='E' then do 
   sect1=substr(ain,1,iat)
end /* do */


desc.1='2c'x ; desc.1.!val='image'
desc.2='21'x ; desc.2.!val='extension'
desc.3='3b'x ; desc.3.!val='trailer'

ext.1='f9'x ; ext.1.!val='graphic control'
ext.2='fe'x ; ext.2.!val='comment'
ext.3='01'x ; ext.3.!val='plain text'
ext.4='ff'x ; ext.4.!val='application'

nimgs=0 ; ngcs=0 ; ncmts=0 ; napps=0 ; nptxts=0

do forever              /* scan the gif file */

if atype='E' & nimgs=getnth then do    /* got nth image -- write and leave */
   goom=sect1||section_gc||section_image||termx
   ff=charout(afilenew,goom,1)
   oo=stream(afilenew,'c','close')
   if ff<>0 then return 0
   return 1
end

/* continue processing */
iat=iat+1       
blockid=substr(ain,iat,1)       /* get next block type */

select

   when blockid='00'x then  ares=0
   when blockid=desc.1 then do  /* it's an image */
      nimgs=nimgs+1
      call do_image
      ares=result
   end /* do */

   when blockid=desc.2 then  do      /* extension */
       iat=iat+1                /* get extention type */
       extype=substr(ain,iat,1)
       select                  
          when extype=ext.1 then do     /*graphics control */
            ngcs=ngcs+1
            call graphics_control
            ares=result
          end
          when extype=ext.3  then do    /*plain text */
              nptxts=nptxts+1
              call plain_text  
              ares=result
          end /* do */
          when extype=ext.2 then do     /*comment */
             ncmts=ncmts+1
             call is_comment
             ares=result
          end
          when extype=ext.4 then do     /* application */
             napps=napps+1
             call application_block
             ares=result
          end /* do */

          otherwise  do
             RETURN  -1
          end
       end      /* extype select */
   end          /* extention descriptor */

   when blockid=desc.3 then do
      leave      /* terminator */
   end
   otherwise do
        return -2
   end
end  /* select */

if ares<0 then return ares

end     /* forever */

/* -------------  package output for return */
select
  
/* basic image-file info */
   when atype='S' then return g_width' 'g_height
   when atype='S2' then return g_width' 'g_height' 'nimgs
   otherwise return 0
end

return ''



/************/
do_image:
iat0=iat
      l1=substr(ain,iat+1,2)
      lcl_left=c2d(reverse(l1))
      l2=substr(ain,iat+3,2)
      lcl_top=c2d(reverse(l2))

      l1=substr(ain,iat+5,2)
      lcl_width=c2d(reverse(l1))
      l2=substr(ain,iat+7,2)
      lcl_height=c2d(reverse(l2))
    
      l3=substr(ain,iat+9,1)
      ctable0=x2b(c2x(l3))
      lcl_ct_flag=left(ctable0,1)
      lcl_interlace=substr(ctable0,2,1)
      t1=right(ctable0,3) ; t1=right(t1,8,0)
      lcl_ct_size=x2d(b2x(t1)) ; lcl_ct_size=2**(lcl_ct_size+1)

       skip=lcl_ct_flag*lcl_ct_size*3

       iat=iat+9+skip    /* iat is now just before the table based image */

/* chew up the data block */
       iat=iat+1        /* skip the lzw bits variable */
       imgsize=chew_data()
       if imgsize<0 then return -6

       if atype='E' then section_image=substr(ain,iat0,(iat-iat0)+1)

       return 1 


/*********/
graphics_control:
iat0=iat-1
       iat=iat+2
       pk=substr(ain,iat,1) ; pk=x2b(c2x(pk))
       tc_flag=right(pk,1)
       iat=iat+1
       tmp=reverse(substr(ain,iat,2)) 
       delay=x2d(c2x(tmp))
       iat=iat+2
       tc_index=x2d(c2x(substr(ain,iat,1)))
       iat=iat+1
       term=x2d(c2x(substr(ain,iat,1)))
       if term<>0 then return -8
       if atype='E' then section_gc=substr(ain,iat0,(iat-iat0)+1)
return 1

/*********/
application_block:
iat=iat+1
app_blocksize=x2d(c2x(substr(ain,iat,1)))
if app_blocksize<>11 then   return -3

iat=iat+1

app_id=substr(ain,iat,8)
iat=iat+8
app_auth=substr(ain,iat,3)
iat=iat+2
appsize=chew_data()
if appsize<0 then return -33

return 1

/***********/
plain_text:
iat=iat+1
app_blocksize=x2d(c2x(substr(ain,iat,1)))
if ptextblocksize<>12 then  return -4

  l1=substr(ain,iat+1,2)
pt_left=c2d(reverse(l1))
  l2=substr(ain,iat+3,2)
pt_top=c2d(reverse(l2))

   l1=substr(ain,iat+5,2)
pt_width=c2d(reverse(l1))
   l2=substr(ain,iat+7,2)
pt_height=c2d(reverse(l2))
iat=iat+4
pt_size=chew_data(1)
if pt_size<0 then return -44
return 1

/*********/
is_comment:
csize=chew_data(1)
if csize<0 then return -7
return 1

/*********/
chew_data:procedure expose iat ain amess filesize
parse arg keep
       totsize=0
       amess=''
       do forever       /* data blocks */
         if iat>filesize then do
             return -5
         end /* do */
         iat=iat+1      /* size of block */
         ii=substr(ain,iat,1) ; ii=c2d(ii)
         if ii=0 then do 
             leave
         end /* do */
         iat=iat+1
         if keep<>0 then amess=amess||substr(ain,iat,ii)
         totsize=totsize+ii
         iat=iat+ii-1
       end /* do */
   return totsize




/* 'FILE or SREF_GOS */
gofile:procedure
parse arg afile

aa=value('SREF_PREFIX',,'os2environment')
if aa='' then 
  afile
else
  foo=sref_gos(afile)

return 0

